"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Bid = exports.Auctions = exports.Auction = exports.Params = exports.protobufPackage = void 0;
/* eslint-disable */
const coin_1 = require("../../../cosmos/base/v1beta1/coin");
const timestamp_1 = require("../../../google/protobuf/timestamp");
const long_1 = __importDefault(require("long"));
const minimal_1 = __importDefault(require("protobufjs/minimal"));
exports.protobufPackage = "cerc.auction.v1";
function createBaseParams() {
    return {};
}
exports.Params = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParams();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseParams();
        return message;
    },
};
function createBaseAuction() {
    return {
        id: "",
        kind: "",
        status: "",
        ownerAddress: "",
        createTime: undefined,
        commitsEndTime: undefined,
        revealsEndTime: undefined,
        commitFee: undefined,
        revealFee: undefined,
        minimumBid: undefined,
        winnerAddresses: [],
        winningBids: [],
        winningPrice: undefined,
        maxPrice: undefined,
        numProviders: 0,
        fundsReleased: false,
    };
}
exports.Auction = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        if (message.kind !== "") {
            writer.uint32(18).string(message.kind);
        }
        if (message.status !== "") {
            writer.uint32(26).string(message.status);
        }
        if (message.ownerAddress !== "") {
            writer.uint32(34).string(message.ownerAddress);
        }
        if (message.createTime !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.createTime), writer.uint32(42).fork()).ldelim();
        }
        if (message.commitsEndTime !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.commitsEndTime), writer.uint32(50).fork()).ldelim();
        }
        if (message.revealsEndTime !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.revealsEndTime), writer.uint32(58).fork()).ldelim();
        }
        if (message.commitFee !== undefined) {
            coin_1.Coin.encode(message.commitFee, writer.uint32(66).fork()).ldelim();
        }
        if (message.revealFee !== undefined) {
            coin_1.Coin.encode(message.revealFee, writer.uint32(74).fork()).ldelim();
        }
        if (message.minimumBid !== undefined) {
            coin_1.Coin.encode(message.minimumBid, writer.uint32(82).fork()).ldelim();
        }
        for (const v of message.winnerAddresses) {
            writer.uint32(90).string(v);
        }
        for (const v of message.winningBids) {
            coin_1.Coin.encode(v, writer.uint32(98).fork()).ldelim();
        }
        if (message.winningPrice !== undefined) {
            coin_1.Coin.encode(message.winningPrice, writer.uint32(106).fork()).ldelim();
        }
        if (message.maxPrice !== undefined) {
            coin_1.Coin.encode(message.maxPrice, writer.uint32(114).fork()).ldelim();
        }
        if (message.numProviders !== 0) {
            writer.uint32(120).int32(message.numProviders);
        }
        if (message.fundsReleased === true) {
            writer.uint32(128).bool(message.fundsReleased);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAuction();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.kind = reader.string();
                    break;
                case 3:
                    message.status = reader.string();
                    break;
                case 4:
                    message.ownerAddress = reader.string();
                    break;
                case 5:
                    message.createTime = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 6:
                    message.commitsEndTime = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 7:
                    message.revealsEndTime = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 8:
                    message.commitFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 9:
                    message.revealFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 10:
                    message.minimumBid = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 11:
                    message.winnerAddresses.push(reader.string());
                    break;
                case 12:
                    message.winningBids.push(coin_1.Coin.decode(reader, reader.uint32()));
                    break;
                case 13:
                    message.winningPrice = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 14:
                    message.maxPrice = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 15:
                    message.numProviders = reader.int32();
                    break;
                case 16:
                    message.fundsReleased = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
            kind: isSet(object.kind) ? String(object.kind) : "",
            status: isSet(object.status) ? String(object.status) : "",
            ownerAddress: isSet(object.ownerAddress)
                ? String(object.ownerAddress)
                : "",
            createTime: isSet(object.createTime)
                ? fromJsonTimestamp(object.createTime)
                : undefined,
            commitsEndTime: isSet(object.commitsEndTime)
                ? fromJsonTimestamp(object.commitsEndTime)
                : undefined,
            revealsEndTime: isSet(object.revealsEndTime)
                ? fromJsonTimestamp(object.revealsEndTime)
                : undefined,
            commitFee: isSet(object.commitFee)
                ? coin_1.Coin.fromJSON(object.commitFee)
                : undefined,
            revealFee: isSet(object.revealFee)
                ? coin_1.Coin.fromJSON(object.revealFee)
                : undefined,
            minimumBid: isSet(object.minimumBid)
                ? coin_1.Coin.fromJSON(object.minimumBid)
                : undefined,
            winnerAddresses: Array.isArray(object === null || object === void 0 ? void 0 : object.winnerAddresses)
                ? object.winnerAddresses.map((e) => String(e))
                : [],
            winningBids: Array.isArray(object === null || object === void 0 ? void 0 : object.winningBids)
                ? object.winningBids.map((e) => coin_1.Coin.fromJSON(e))
                : [],
            winningPrice: isSet(object.winningPrice)
                ? coin_1.Coin.fromJSON(object.winningPrice)
                : undefined,
            maxPrice: isSet(object.maxPrice)
                ? coin_1.Coin.fromJSON(object.maxPrice)
                : undefined,
            numProviders: isSet(object.numProviders)
                ? Number(object.numProviders)
                : 0,
            fundsReleased: isSet(object.fundsReleased)
                ? Boolean(object.fundsReleased)
                : false,
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        message.kind !== undefined && (obj.kind = message.kind);
        message.status !== undefined && (obj.status = message.status);
        message.ownerAddress !== undefined &&
            (obj.ownerAddress = message.ownerAddress);
        message.createTime !== undefined &&
            (obj.createTime = message.createTime.toISOString());
        message.commitsEndTime !== undefined &&
            (obj.commitsEndTime = message.commitsEndTime.toISOString());
        message.revealsEndTime !== undefined &&
            (obj.revealsEndTime = message.revealsEndTime.toISOString());
        message.commitFee !== undefined &&
            (obj.commitFee = message.commitFee
                ? coin_1.Coin.toJSON(message.commitFee)
                : undefined);
        message.revealFee !== undefined &&
            (obj.revealFee = message.revealFee
                ? coin_1.Coin.toJSON(message.revealFee)
                : undefined);
        message.minimumBid !== undefined &&
            (obj.minimumBid = message.minimumBid
                ? coin_1.Coin.toJSON(message.minimumBid)
                : undefined);
        if (message.winnerAddresses) {
            obj.winnerAddresses = message.winnerAddresses.map((e) => e);
        }
        else {
            obj.winnerAddresses = [];
        }
        if (message.winningBids) {
            obj.winningBids = message.winningBids.map((e) => e ? coin_1.Coin.toJSON(e) : undefined);
        }
        else {
            obj.winningBids = [];
        }
        message.winningPrice !== undefined &&
            (obj.winningPrice = message.winningPrice
                ? coin_1.Coin.toJSON(message.winningPrice)
                : undefined);
        message.maxPrice !== undefined &&
            (obj.maxPrice = message.maxPrice
                ? coin_1.Coin.toJSON(message.maxPrice)
                : undefined);
        message.numProviders !== undefined &&
            (obj.numProviders = Math.round(message.numProviders));
        message.fundsReleased !== undefined &&
            (obj.fundsReleased = message.fundsReleased);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
        const message = createBaseAuction();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : "";
        message.kind = (_b = object.kind) !== null && _b !== void 0 ? _b : "";
        message.status = (_c = object.status) !== null && _c !== void 0 ? _c : "";
        message.ownerAddress = (_d = object.ownerAddress) !== null && _d !== void 0 ? _d : "";
        message.createTime = (_e = object.createTime) !== null && _e !== void 0 ? _e : undefined;
        message.commitsEndTime = (_f = object.commitsEndTime) !== null && _f !== void 0 ? _f : undefined;
        message.revealsEndTime = (_g = object.revealsEndTime) !== null && _g !== void 0 ? _g : undefined;
        message.commitFee =
            object.commitFee !== undefined && object.commitFee !== null
                ? coin_1.Coin.fromPartial(object.commitFee)
                : undefined;
        message.revealFee =
            object.revealFee !== undefined && object.revealFee !== null
                ? coin_1.Coin.fromPartial(object.revealFee)
                : undefined;
        message.minimumBid =
            object.minimumBid !== undefined && object.minimumBid !== null
                ? coin_1.Coin.fromPartial(object.minimumBid)
                : undefined;
        message.winnerAddresses = ((_h = object.winnerAddresses) === null || _h === void 0 ? void 0 : _h.map((e) => e)) || [];
        message.winningBids =
            ((_j = object.winningBids) === null || _j === void 0 ? void 0 : _j.map((e) => coin_1.Coin.fromPartial(e))) || [];
        message.winningPrice =
            object.winningPrice !== undefined && object.winningPrice !== null
                ? coin_1.Coin.fromPartial(object.winningPrice)
                : undefined;
        message.maxPrice =
            object.maxPrice !== undefined && object.maxPrice !== null
                ? coin_1.Coin.fromPartial(object.maxPrice)
                : undefined;
        message.numProviders = (_k = object.numProviders) !== null && _k !== void 0 ? _k : 0;
        message.fundsReleased = (_l = object.fundsReleased) !== null && _l !== void 0 ? _l : false;
        return message;
    },
};
function createBaseAuctions() {
    return { auctions: [] };
}
exports.Auctions = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        for (const v of message.auctions) {
            exports.Auction.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAuctions();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auctions.push(exports.Auction.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auctions: Array.isArray(object === null || object === void 0 ? void 0 : object.auctions)
                ? object.auctions.map((e) => exports.Auction.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.auctions) {
            obj.auctions = message.auctions.map((e) => e ? exports.Auction.toJSON(e) : undefined);
        }
        else {
            obj.auctions = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseAuctions();
        message.auctions =
            ((_a = object.auctions) === null || _a === void 0 ? void 0 : _a.map((e) => exports.Auction.fromPartial(e))) || [];
        return message;
    },
};
function createBaseBid() {
    return {
        auctionId: "",
        bidderAddress: "",
        status: "",
        commitHash: "",
        commitTime: undefined,
        commitFee: undefined,
        revealTime: undefined,
        revealFee: undefined,
        bidAmount: undefined,
    };
}
exports.Bid = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.auctionId !== "") {
            writer.uint32(10).string(message.auctionId);
        }
        if (message.bidderAddress !== "") {
            writer.uint32(18).string(message.bidderAddress);
        }
        if (message.status !== "") {
            writer.uint32(26).string(message.status);
        }
        if (message.commitHash !== "") {
            writer.uint32(34).string(message.commitHash);
        }
        if (message.commitTime !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.commitTime), writer.uint32(42).fork()).ldelim();
        }
        if (message.commitFee !== undefined) {
            coin_1.Coin.encode(message.commitFee, writer.uint32(50).fork()).ldelim();
        }
        if (message.revealTime !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.revealTime), writer.uint32(58).fork()).ldelim();
        }
        if (message.revealFee !== undefined) {
            coin_1.Coin.encode(message.revealFee, writer.uint32(66).fork()).ldelim();
        }
        if (message.bidAmount !== undefined) {
            coin_1.Coin.encode(message.bidAmount, writer.uint32(74).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseBid();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auctionId = reader.string();
                    break;
                case 2:
                    message.bidderAddress = reader.string();
                    break;
                case 3:
                    message.status = reader.string();
                    break;
                case 4:
                    message.commitHash = reader.string();
                    break;
                case 5:
                    message.commitTime = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 6:
                    message.commitFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 7:
                    message.revealTime = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 8:
                    message.revealFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 9:
                    message.bidAmount = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auctionId: isSet(object.auctionId) ? String(object.auctionId) : "",
            bidderAddress: isSet(object.bidderAddress)
                ? String(object.bidderAddress)
                : "",
            status: isSet(object.status) ? String(object.status) : "",
            commitHash: isSet(object.commitHash) ? String(object.commitHash) : "",
            commitTime: isSet(object.commitTime)
                ? fromJsonTimestamp(object.commitTime)
                : undefined,
            commitFee: isSet(object.commitFee)
                ? coin_1.Coin.fromJSON(object.commitFee)
                : undefined,
            revealTime: isSet(object.revealTime)
                ? fromJsonTimestamp(object.revealTime)
                : undefined,
            revealFee: isSet(object.revealFee)
                ? coin_1.Coin.fromJSON(object.revealFee)
                : undefined,
            bidAmount: isSet(object.bidAmount)
                ? coin_1.Coin.fromJSON(object.bidAmount)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.auctionId !== undefined && (obj.auctionId = message.auctionId);
        message.bidderAddress !== undefined &&
            (obj.bidderAddress = message.bidderAddress);
        message.status !== undefined && (obj.status = message.status);
        message.commitHash !== undefined && (obj.commitHash = message.commitHash);
        message.commitTime !== undefined &&
            (obj.commitTime = message.commitTime.toISOString());
        message.commitFee !== undefined &&
            (obj.commitFee = message.commitFee
                ? coin_1.Coin.toJSON(message.commitFee)
                : undefined);
        message.revealTime !== undefined &&
            (obj.revealTime = message.revealTime.toISOString());
        message.revealFee !== undefined &&
            (obj.revealFee = message.revealFee
                ? coin_1.Coin.toJSON(message.revealFee)
                : undefined);
        message.bidAmount !== undefined &&
            (obj.bidAmount = message.bidAmount
                ? coin_1.Coin.toJSON(message.bidAmount)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f;
        const message = createBaseBid();
        message.auctionId = (_a = object.auctionId) !== null && _a !== void 0 ? _a : "";
        message.bidderAddress = (_b = object.bidderAddress) !== null && _b !== void 0 ? _b : "";
        message.status = (_c = object.status) !== null && _c !== void 0 ? _c : "";
        message.commitHash = (_d = object.commitHash) !== null && _d !== void 0 ? _d : "";
        message.commitTime = (_e = object.commitTime) !== null && _e !== void 0 ? _e : undefined;
        message.commitFee =
            object.commitFee !== undefined && object.commitFee !== null
                ? coin_1.Coin.fromPartial(object.commitFee)
                : undefined;
        message.revealTime = (_f = object.revealTime) !== null && _f !== void 0 ? _f : undefined;
        message.revealFee =
            object.revealFee !== undefined && object.revealFee !== null
                ? coin_1.Coin.fromPartial(object.revealFee)
                : undefined;
        message.bidAmount =
            object.bidAmount !== undefined && object.bidAmount !== null
                ? coin_1.Coin.fromPartial(object.bidAmount)
                : undefined;
        return message;
    },
};
function toTimestamp(date) {
    const seconds = numberToLong(date.getTime() / 1000);
    const nanos = (date.getTime() % 1000) * 1000000;
    return { seconds, nanos };
}
function fromTimestamp(t) {
    let millis = t.seconds.toNumber() * 1000;
    millis += t.nanos / 1000000;
    return new Date(millis);
}
function fromJsonTimestamp(o) {
    if (o instanceof Date) {
        return o;
    }
    else if (typeof o === "string") {
        return new Date(o);
    }
    else {
        return fromTimestamp(timestamp_1.Timestamp.fromJSON(o));
    }
}
function numberToLong(number) {
    return long_1.default.fromNumber(number);
}
if (minimal_1.default.util.Long !== long_1.default) {
    minimal_1.default.util.Long = long_1.default;
    minimal_1.default.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
