import { Params, Auctions } from "./auction";
import Long from "long";
import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "cerc.auction.v1";
/** GenesisState defines the genesis state of the auction module */
export interface GenesisState {
    params?: Params;
    auctions?: Auctions;
}
export declare const GenesisState: {
    encode(message: GenesisState, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GenesisState;
    fromJSON(object: any): GenesisState;
    toJSON(message: GenesisState): unknown;
    fromPartial<I extends {
        params?: {} | undefined;
        auctions?: {
            auctions?: {
                id?: string | undefined;
                kind?: string | undefined;
                status?: string | undefined;
                ownerAddress?: string | undefined;
                createTime?: Date | undefined;
                commitsEndTime?: Date | undefined;
                revealsEndTime?: Date | undefined;
                commitFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                revealFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                minimumBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winnerAddresses?: string[] | undefined;
                winningBids?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                }[] | undefined;
                winningPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                maxPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                numProviders?: number | undefined;
                fundsReleased?: boolean | undefined;
            }[] | undefined;
        } | undefined;
    } & {
        params?: ({} & {} & { [K in Exclude<keyof I["params"], never>]: never; }) | undefined;
        auctions?: ({
            auctions?: {
                id?: string | undefined;
                kind?: string | undefined;
                status?: string | undefined;
                ownerAddress?: string | undefined;
                createTime?: Date | undefined;
                commitsEndTime?: Date | undefined;
                revealsEndTime?: Date | undefined;
                commitFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                revealFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                minimumBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winnerAddresses?: string[] | undefined;
                winningBids?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                }[] | undefined;
                winningPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                maxPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                numProviders?: number | undefined;
                fundsReleased?: boolean | undefined;
            }[] | undefined;
        } & {
            auctions?: ({
                id?: string | undefined;
                kind?: string | undefined;
                status?: string | undefined;
                ownerAddress?: string | undefined;
                createTime?: Date | undefined;
                commitsEndTime?: Date | undefined;
                revealsEndTime?: Date | undefined;
                commitFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                revealFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                minimumBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winnerAddresses?: string[] | undefined;
                winningBids?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                }[] | undefined;
                winningPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                maxPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                numProviders?: number | undefined;
                fundsReleased?: boolean | undefined;
            }[] & ({
                id?: string | undefined;
                kind?: string | undefined;
                status?: string | undefined;
                ownerAddress?: string | undefined;
                createTime?: Date | undefined;
                commitsEndTime?: Date | undefined;
                revealsEndTime?: Date | undefined;
                commitFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                revealFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                minimumBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winnerAddresses?: string[] | undefined;
                winningBids?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                }[] | undefined;
                winningPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                maxPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                numProviders?: number | undefined;
                fundsReleased?: boolean | undefined;
            } & {
                id?: string | undefined;
                kind?: string | undefined;
                status?: string | undefined;
                ownerAddress?: string | undefined;
                createTime?: Date | undefined;
                commitsEndTime?: Date | undefined;
                revealsEndTime?: Date | undefined;
                commitFee?: ({
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & { [K_1 in Exclude<keyof I["auctions"]["auctions"][number]["commitFee"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
                revealFee?: ({
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & { [K_2 in Exclude<keyof I["auctions"]["auctions"][number]["revealFee"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
                minimumBid?: ({
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & { [K_3 in Exclude<keyof I["auctions"]["auctions"][number]["minimumBid"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
                winnerAddresses?: (string[] & string[] & { [K_4 in Exclude<keyof I["auctions"]["auctions"][number]["winnerAddresses"], keyof string[]>]: never; }) | undefined;
                winningBids?: ({
                    denom?: string | undefined;
                    amount?: string | undefined;
                }[] & ({
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & { [K_5 in Exclude<keyof I["auctions"]["auctions"][number]["winningBids"][number], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; })[] & { [K_6 in Exclude<keyof I["auctions"]["auctions"][number]["winningBids"], keyof {
                    denom?: string | undefined;
                    amount?: string | undefined;
                }[]>]: never; }) | undefined;
                winningPrice?: ({
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & { [K_7 in Exclude<keyof I["auctions"]["auctions"][number]["winningPrice"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
                maxPrice?: ({
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & { [K_8 in Exclude<keyof I["auctions"]["auctions"][number]["maxPrice"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
                numProviders?: number | undefined;
                fundsReleased?: boolean | undefined;
            } & { [K_9 in Exclude<keyof I["auctions"]["auctions"][number], keyof import("./auction").Auction>]: never; })[] & { [K_10 in Exclude<keyof I["auctions"]["auctions"], keyof {
                id?: string | undefined;
                kind?: string | undefined;
                status?: string | undefined;
                ownerAddress?: string | undefined;
                createTime?: Date | undefined;
                commitsEndTime?: Date | undefined;
                revealsEndTime?: Date | undefined;
                commitFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                revealFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                minimumBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winnerAddresses?: string[] | undefined;
                winningBids?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                }[] | undefined;
                winningPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                maxPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                numProviders?: number | undefined;
                fundsReleased?: boolean | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_11 in Exclude<keyof I["auctions"], "auctions">]: never; }) | undefined;
    } & { [K_12 in Exclude<keyof I, keyof GenesisState>]: never; }>(object: I): GenesisState;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export {};
