import { Params } from "./bond";
import Long from "long";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "cerc.bond.v1";
/** MsgCreateBond defines a SDK message for creating a new bond. */
export interface MsgCreateBond {
    signer: string;
    coins: Coin[];
}
/** MsgCreateBondResponse defines the Msg/CreateBond response type. */
export interface MsgCreateBondResponse {
    id: string;
}
/** MsgRefillBond defines a SDK message for refill the amount for bond. */
export interface MsgRefillBond {
    id: string;
    signer: string;
    coins: Coin[];
}
/** MsgRefillBondResponse defines the Msg/RefillBond response type. */
export interface MsgRefillBondResponse {
}
/** MsgWithdrawBond defines a SDK message for withdrawing amount from bond. */
export interface MsgWithdrawBond {
    id: string;
    signer: string;
    coins: Coin[];
}
/** MsgWithdrawBondResponse defines the Msg/WithdrawBond response type. */
export interface MsgWithdrawBondResponse {
}
/** MsgCancelBond defines a SDK message for the cancel the bond. */
export interface MsgCancelBond {
    id: string;
    signer: string;
}
/** MsgCancelBondResponse defines the Msg/CancelBond response type. */
export interface MsgCancelBondResponse {
}
/** MsgUpdateParams is the Msg/UpdateParams request type. */
export interface MsgUpdateParams {
    /**
     * authority is the address that controls the module (defaults to x/gov unless
     * overwritten).
     */
    authority: string;
    /**
     * params defines the x/bond parameters to update.
     *
     * NOTE: All parameters must be supplied.
     */
    params?: Params;
}
/**
 * MsgUpdateParamsResponse defines the response structure for executing a
 * MsgUpdateParams message.
 */
export interface MsgUpdateParamsResponse {
}
export declare const MsgCreateBond: {
    encode(message: MsgCreateBond, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgCreateBond;
    fromJSON(object: any): MsgCreateBond;
    toJSON(message: MsgCreateBond): unknown;
    fromPartial<I extends {
        signer?: string | undefined;
        coins?: {
            denom?: string | undefined;
            amount?: string | undefined;
        }[] | undefined;
    } & {
        signer?: string | undefined;
        coins?: ({
            denom?: string | undefined;
            amount?: string | undefined;
        }[] & ({
            denom?: string | undefined;
            amount?: string | undefined;
        } & {
            denom?: string | undefined;
            amount?: string | undefined;
        } & { [K in Exclude<keyof I["coins"][number], keyof Coin>]: never; })[] & { [K_1 in Exclude<keyof I["coins"], keyof {
            denom?: string | undefined;
            amount?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_2 in Exclude<keyof I, keyof MsgCreateBond>]: never; }>(object: I): MsgCreateBond;
};
export declare const MsgCreateBondResponse: {
    encode(message: MsgCreateBondResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgCreateBondResponse;
    fromJSON(object: any): MsgCreateBondResponse;
    toJSON(message: MsgCreateBondResponse): unknown;
    fromPartial<I extends {
        id?: string | undefined;
    } & {
        id?: string | undefined;
    } & { [K in Exclude<keyof I, "id">]: never; }>(object: I): MsgCreateBondResponse;
};
export declare const MsgRefillBond: {
    encode(message: MsgRefillBond, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgRefillBond;
    fromJSON(object: any): MsgRefillBond;
    toJSON(message: MsgRefillBond): unknown;
    fromPartial<I extends {
        id?: string | undefined;
        signer?: string | undefined;
        coins?: {
            denom?: string | undefined;
            amount?: string | undefined;
        }[] | undefined;
    } & {
        id?: string | undefined;
        signer?: string | undefined;
        coins?: ({
            denom?: string | undefined;
            amount?: string | undefined;
        }[] & ({
            denom?: string | undefined;
            amount?: string | undefined;
        } & {
            denom?: string | undefined;
            amount?: string | undefined;
        } & { [K in Exclude<keyof I["coins"][number], keyof Coin>]: never; })[] & { [K_1 in Exclude<keyof I["coins"], keyof {
            denom?: string | undefined;
            amount?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_2 in Exclude<keyof I, keyof MsgRefillBond>]: never; }>(object: I): MsgRefillBond;
};
export declare const MsgRefillBondResponse: {
    encode(_: MsgRefillBondResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgRefillBondResponse;
    fromJSON(_: any): MsgRefillBondResponse;
    toJSON(_: MsgRefillBondResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgRefillBondResponse;
};
export declare const MsgWithdrawBond: {
    encode(message: MsgWithdrawBond, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgWithdrawBond;
    fromJSON(object: any): MsgWithdrawBond;
    toJSON(message: MsgWithdrawBond): unknown;
    fromPartial<I extends {
        id?: string | undefined;
        signer?: string | undefined;
        coins?: {
            denom?: string | undefined;
            amount?: string | undefined;
        }[] | undefined;
    } & {
        id?: string | undefined;
        signer?: string | undefined;
        coins?: ({
            denom?: string | undefined;
            amount?: string | undefined;
        }[] & ({
            denom?: string | undefined;
            amount?: string | undefined;
        } & {
            denom?: string | undefined;
            amount?: string | undefined;
        } & { [K in Exclude<keyof I["coins"][number], keyof Coin>]: never; })[] & { [K_1 in Exclude<keyof I["coins"], keyof {
            denom?: string | undefined;
            amount?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_2 in Exclude<keyof I, keyof MsgWithdrawBond>]: never; }>(object: I): MsgWithdrawBond;
};
export declare const MsgWithdrawBondResponse: {
    encode(_: MsgWithdrawBondResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgWithdrawBondResponse;
    fromJSON(_: any): MsgWithdrawBondResponse;
    toJSON(_: MsgWithdrawBondResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgWithdrawBondResponse;
};
export declare const MsgCancelBond: {
    encode(message: MsgCancelBond, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgCancelBond;
    fromJSON(object: any): MsgCancelBond;
    toJSON(message: MsgCancelBond): unknown;
    fromPartial<I extends {
        id?: string | undefined;
        signer?: string | undefined;
    } & {
        id?: string | undefined;
        signer?: string | undefined;
    } & { [K in Exclude<keyof I, keyof MsgCancelBond>]: never; }>(object: I): MsgCancelBond;
};
export declare const MsgCancelBondResponse: {
    encode(_: MsgCancelBondResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgCancelBondResponse;
    fromJSON(_: any): MsgCancelBondResponse;
    toJSON(_: MsgCancelBondResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgCancelBondResponse;
};
export declare const MsgUpdateParams: {
    encode(message: MsgUpdateParams, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgUpdateParams;
    fromJSON(object: any): MsgUpdateParams;
    toJSON(message: MsgUpdateParams): unknown;
    fromPartial<I extends {
        authority?: string | undefined;
        params?: {
            maxBondAmount?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
        } | undefined;
    } & {
        authority?: string | undefined;
        params?: ({
            maxBondAmount?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
        } & {
            maxBondAmount?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K in Exclude<keyof I["params"]["maxBondAmount"], keyof Coin>]: never; }) | undefined;
        } & { [K_1 in Exclude<keyof I["params"], "maxBondAmount">]: never; }) | undefined;
    } & { [K_2 in Exclude<keyof I, keyof MsgUpdateParams>]: never; }>(object: I): MsgUpdateParams;
};
export declare const MsgUpdateParamsResponse: {
    encode(_: MsgUpdateParamsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgUpdateParamsResponse;
    fromJSON(_: any): MsgUpdateParamsResponse;
    toJSON(_: MsgUpdateParamsResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgUpdateParamsResponse;
};
/** Msg defines the bond Msg service. */
export interface Msg {
    /** CreateBond defines a method for creating a new bond. */
    CreateBond(request: MsgCreateBond): Promise<MsgCreateBondResponse>;
    /** RefillBond defines a method for refilling amount for bond. */
    RefillBond(request: MsgRefillBond): Promise<MsgRefillBondResponse>;
    /** WithdrawBond defines a method for withdrawing amount from bond. */
    WithdrawBond(request: MsgWithdrawBond): Promise<MsgWithdrawBondResponse>;
    /** CancelBond defines a method for cancelling a bond. */
    CancelBond(request: MsgCancelBond): Promise<MsgCancelBondResponse>;
    /**
     * UpdateParams defines an operation for updating the x/staking module
     * parameters.
     */
    UpdateParams(request: MsgUpdateParams): Promise<MsgUpdateParamsResponse>;
}
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    constructor(rpc: Rpc);
    CreateBond(request: MsgCreateBond): Promise<MsgCreateBondResponse>;
    RefillBond(request: MsgRefillBond): Promise<MsgRefillBondResponse>;
    WithdrawBond(request: MsgWithdrawBond): Promise<MsgWithdrawBondResponse>;
    CancelBond(request: MsgCancelBond): Promise<MsgCancelBondResponse>;
    UpdateParams(request: MsgUpdateParams): Promise<MsgUpdateParamsResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export {};
