import Long from "long";
import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "cerc.onboarding.v1";
/** Params defines the parameters of the onboarding module. */
export interface Params {
    onboardingEnabled: boolean;
}
/**
 * Participant defines the data that will be stored for each enrolled
 * participant
 */
export interface Participant {
    /** participant's cosmos (laconic) address */
    cosmosAddress: string;
    /** participant's Nitro address */
    nitroAddress: string;
    /** participant's role (participant | validator) */
    role: string;
    /** participant's KYC receipt ID */
    kycId: string;
}
/** EthPayload defines the payload that is signed by the ethereum private key */
export interface EthPayload {
    address: string;
    msg: string;
}
export declare const Params: {
    encode(message: Params, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): Params;
    fromJSON(object: any): Params;
    toJSON(message: Params): unknown;
    fromPartial<I extends {
        onboardingEnabled?: boolean | undefined;
    } & {
        onboardingEnabled?: boolean | undefined;
    } & { [K in Exclude<keyof I, "onboardingEnabled">]: never; }>(object: I): Params;
};
export declare const Participant: {
    encode(message: Participant, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): Participant;
    fromJSON(object: any): Participant;
    toJSON(message: Participant): unknown;
    fromPartial<I extends {
        cosmosAddress?: string | undefined;
        nitroAddress?: string | undefined;
        role?: string | undefined;
        kycId?: string | undefined;
    } & {
        cosmosAddress?: string | undefined;
        nitroAddress?: string | undefined;
        role?: string | undefined;
        kycId?: string | undefined;
    } & { [K in Exclude<keyof I, keyof Participant>]: never; }>(object: I): Participant;
};
export declare const EthPayload: {
    encode(message: EthPayload, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EthPayload;
    fromJSON(object: any): EthPayload;
    toJSON(message: EthPayload): unknown;
    fromPartial<I extends {
        address?: string | undefined;
        msg?: string | undefined;
    } & {
        address?: string | undefined;
        msg?: string | undefined;
    } & { [K in Exclude<keyof I, keyof EthPayload>]: never; }>(object: I): EthPayload;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export {};
