"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryClientImpl = exports.QueryGetParticipantByNitroAddressResponse = exports.QueryGetParticipantByNitroAddressRequest = exports.QueryGetParticipantByAddressResponse = exports.QueryGetParticipantByAddressRequest = exports.QueryParticipantsResponse = exports.QueryParticipantsRequest = exports.protobufPackage = void 0;
/* eslint-disable */
const pagination_1 = require("../../../cosmos/base/query/v1beta1/pagination");
const onboarding_1 = require("./onboarding");
const long_1 = __importDefault(require("long"));
const minimal_1 = __importDefault(require("protobufjs/minimal"));
exports.protobufPackage = "cerc.onboarding.v1";
function createBaseQueryParticipantsRequest() {
    return { pagination: undefined };
}
exports.QueryParticipantsRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.pagination !== undefined) {
            pagination_1.PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParticipantsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = pagination_1.PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            pagination: isSet(object.pagination)
                ? pagination_1.PageRequest.fromJSON(object.pagination)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? pagination_1.PageRequest.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryParticipantsRequest();
        message.pagination =
            object.pagination !== undefined && object.pagination !== null
                ? pagination_1.PageRequest.fromPartial(object.pagination)
                : undefined;
        return message;
    },
};
function createBaseQueryParticipantsResponse() {
    return { participants: [], pagination: undefined };
}
exports.QueryParticipantsResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        for (const v of message.participants) {
            onboarding_1.Participant.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            pagination_1.PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParticipantsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.participants.push(onboarding_1.Participant.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = pagination_1.PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            participants: Array.isArray(object === null || object === void 0 ? void 0 : object.participants)
                ? object.participants.map((e) => onboarding_1.Participant.fromJSON(e))
                : [],
            pagination: isSet(object.pagination)
                ? pagination_1.PageResponse.fromJSON(object.pagination)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.participants) {
            obj.participants = message.participants.map((e) => e ? onboarding_1.Participant.toJSON(e) : undefined);
        }
        else {
            obj.participants = [];
        }
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? pagination_1.PageResponse.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryParticipantsResponse();
        message.participants =
            ((_a = object.participants) === null || _a === void 0 ? void 0 : _a.map((e) => onboarding_1.Participant.fromPartial(e))) || [];
        message.pagination =
            object.pagination !== undefined && object.pagination !== null
                ? pagination_1.PageResponse.fromPartial(object.pagination)
                : undefined;
        return message;
    },
};
function createBaseQueryGetParticipantByAddressRequest() {
    return { address: "" };
}
exports.QueryGetParticipantByAddressRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.address !== "") {
            writer.uint32(10).string(message.address);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetParticipantByAddressRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.address = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            address: isSet(object.address) ? String(object.address) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.address !== undefined && (obj.address = message.address);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryGetParticipantByAddressRequest();
        message.address = (_a = object.address) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseQueryGetParticipantByAddressResponse() {
    return { participant: undefined };
}
exports.QueryGetParticipantByAddressResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.participant !== undefined) {
            onboarding_1.Participant.encode(message.participant, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetParticipantByAddressResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.participant = onboarding_1.Participant.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            participant: isSet(object.participant)
                ? onboarding_1.Participant.fromJSON(object.participant)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.participant !== undefined &&
            (obj.participant = message.participant
                ? onboarding_1.Participant.toJSON(message.participant)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryGetParticipantByAddressResponse();
        message.participant =
            object.participant !== undefined && object.participant !== null
                ? onboarding_1.Participant.fromPartial(object.participant)
                : undefined;
        return message;
    },
};
function createBaseQueryGetParticipantByNitroAddressRequest() {
    return { nitroAddress: "" };
}
exports.QueryGetParticipantByNitroAddressRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.nitroAddress !== "") {
            writer.uint32(10).string(message.nitroAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetParticipantByNitroAddressRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.nitroAddress = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            nitroAddress: isSet(object.nitroAddress)
                ? String(object.nitroAddress)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.nitroAddress !== undefined &&
            (obj.nitroAddress = message.nitroAddress);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryGetParticipantByNitroAddressRequest();
        message.nitroAddress = (_a = object.nitroAddress) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseQueryGetParticipantByNitroAddressResponse() {
    return { participant: undefined };
}
exports.QueryGetParticipantByNitroAddressResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.participant !== undefined) {
            onboarding_1.Participant.encode(message.participant, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetParticipantByNitroAddressResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.participant = onboarding_1.Participant.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            participant: isSet(object.participant)
                ? onboarding_1.Participant.fromJSON(object.participant)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.participant !== undefined &&
            (obj.participant = message.participant
                ? onboarding_1.Participant.toJSON(message.participant)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryGetParticipantByNitroAddressResponse();
        message.participant =
            object.participant !== undefined && object.participant !== null
                ? onboarding_1.Participant.fromPartial(object.participant)
                : undefined;
        return message;
    },
};
class QueryClientImpl {
    constructor(rpc) {
        this.rpc = rpc;
        this.Participants = this.Participants.bind(this);
        this.GetParticipantByAddress = this.GetParticipantByAddress.bind(this);
        this.GetParticipantByNitroAddress =
            this.GetParticipantByNitroAddress.bind(this);
    }
    Participants(request) {
        const data = exports.QueryParticipantsRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.onboarding.v1.Query", "Participants", data);
        return promise.then((data) => exports.QueryParticipantsResponse.decode(new minimal_1.default.Reader(data)));
    }
    GetParticipantByAddress(request) {
        const data = exports.QueryGetParticipantByAddressRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.onboarding.v1.Query", "GetParticipantByAddress", data);
        return promise.then((data) => exports.QueryGetParticipantByAddressResponse.decode(new minimal_1.default.Reader(data)));
    }
    GetParticipantByNitroAddress(request) {
        const data = exports.QueryGetParticipantByNitroAddressRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.onboarding.v1.Query", "GetParticipantByNitroAddress", data);
        return promise.then((data) => exports.QueryGetParticipantByNitroAddressResponse.decode(new minimal_1.default.Reader(data)));
    }
}
exports.QueryClientImpl = QueryClientImpl;
if (minimal_1.default.util.Long !== long_1.default) {
    minimal_1.default.util.Long = long_1.default;
    minimal_1.default.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
