import { EthPayload } from "./onboarding";
import Long from "long";
import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "cerc.onboarding.v1";
/** MsgOnboardParticipant defines a SDK message for enrolling a new validator. */
export interface MsgOnboardParticipant {
    /** Participant is the msg sender */
    participant: string;
    ethPayload?: EthPayload;
    ethSignature: string;
    role: string;
    kycId: string;
}
/**
 * MsgOnboardParticipantResponse defines the Msg/OnboardParticipant response
 * type.
 */
export interface MsgOnboardParticipantResponse {
}
export declare const MsgOnboardParticipant: {
    encode(message: MsgOnboardParticipant, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgOnboardParticipant;
    fromJSON(object: any): MsgOnboardParticipant;
    toJSON(message: MsgOnboardParticipant): unknown;
    fromPartial<I extends {
        participant?: string | undefined;
        ethPayload?: {
            address?: string | undefined;
            msg?: string | undefined;
        } | undefined;
        ethSignature?: string | undefined;
        role?: string | undefined;
        kycId?: string | undefined;
    } & {
        participant?: string | undefined;
        ethPayload?: ({
            address?: string | undefined;
            msg?: string | undefined;
        } & {
            address?: string | undefined;
            msg?: string | undefined;
        } & { [K in Exclude<keyof I["ethPayload"], keyof EthPayload>]: never; }) | undefined;
        ethSignature?: string | undefined;
        role?: string | undefined;
        kycId?: string | undefined;
    } & { [K_1 in Exclude<keyof I, keyof MsgOnboardParticipant>]: never; }>(object: I): MsgOnboardParticipant;
};
export declare const MsgOnboardParticipantResponse: {
    encode(_: MsgOnboardParticipantResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgOnboardParticipantResponse;
    fromJSON(_: any): MsgOnboardParticipantResponse;
    toJSON(_: MsgOnboardParticipantResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgOnboardParticipantResponse;
};
/** Msg defines the onboarding Msg service. */
export interface Msg {
    /** OnboardParticipant defines a method for enrolling a new validator. */
    OnboardParticipant(request: MsgOnboardParticipant): Promise<MsgOnboardParticipantResponse>;
}
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    constructor(rpc: Rpc);
    OnboardParticipant(request: MsgOnboardParticipant): Promise<MsgOnboardParticipantResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export {};
