"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenesisState = exports.protobufPackage = void 0;
/* eslint-disable */
const registry_1 = require("./registry");
const long_1 = __importDefault(require("long"));
const minimal_1 = __importDefault(require("protobufjs/minimal"));
exports.protobufPackage = "cerc.registry.v1";
function createBaseGenesisState() {
    return { params: undefined, records: [], authorities: [], names: [] };
}
exports.GenesisState = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.params !== undefined) {
            registry_1.Params.encode(message.params, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.records) {
            registry_1.Record.encode(v, writer.uint32(18).fork()).ldelim();
        }
        for (const v of message.authorities) {
            registry_1.AuthorityEntry.encode(v, writer.uint32(26).fork()).ldelim();
        }
        for (const v of message.names) {
            registry_1.NameEntry.encode(v, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenesisState();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.params = registry_1.Params.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.records.push(registry_1.Record.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.authorities.push(registry_1.AuthorityEntry.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.names.push(registry_1.NameEntry.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            params: isSet(object.params) ? registry_1.Params.fromJSON(object.params) : undefined,
            records: Array.isArray(object === null || object === void 0 ? void 0 : object.records)
                ? object.records.map((e) => registry_1.Record.fromJSON(e))
                : [],
            authorities: Array.isArray(object === null || object === void 0 ? void 0 : object.authorities)
                ? object.authorities.map((e) => registry_1.AuthorityEntry.fromJSON(e))
                : [],
            names: Array.isArray(object === null || object === void 0 ? void 0 : object.names)
                ? object.names.map((e) => registry_1.NameEntry.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.params !== undefined &&
            (obj.params = message.params ? registry_1.Params.toJSON(message.params) : undefined);
        if (message.records) {
            obj.records = message.records.map((e) => e ? registry_1.Record.toJSON(e) : undefined);
        }
        else {
            obj.records = [];
        }
        if (message.authorities) {
            obj.authorities = message.authorities.map((e) => e ? registry_1.AuthorityEntry.toJSON(e) : undefined);
        }
        else {
            obj.authorities = [];
        }
        if (message.names) {
            obj.names = message.names.map((e) => e ? registry_1.NameEntry.toJSON(e) : undefined);
        }
        else {
            obj.names = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseGenesisState();
        message.params =
            object.params !== undefined && object.params !== null
                ? registry_1.Params.fromPartial(object.params)
                : undefined;
        message.records = ((_a = object.records) === null || _a === void 0 ? void 0 : _a.map((e) => registry_1.Record.fromPartial(e))) || [];
        message.authorities =
            ((_b = object.authorities) === null || _b === void 0 ? void 0 : _b.map((e) => registry_1.AuthorityEntry.fromPartial(e))) || [];
        message.names = ((_c = object.names) === null || _c === void 0 ? void 0 : _c.map((e) => registry_1.NameEntry.fromPartial(e))) || [];
        return message;
    },
};
if (minimal_1.default.util.Long !== long_1.default) {
    minimal_1.default.util.Long = long_1.default;
    minimal_1.default.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
