"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryClientImpl = exports.AccountBalance = exports.QueryGetRegistryModuleBalanceResponse = exports.QueryGetRegistryModuleBalanceRequest = exports.QueryResolveLrnResponse = exports.QueryResolveLrnRequest = exports.QueryLookupLrnResponse = exports.QueryLookupLrnRequest = exports.QueryAuthoritiesResponse = exports.QueryAuthoritiesRequest = exports.QueryWhoisResponse = exports.QueryWhoisRequest = exports.QueryNameRecordsResponse = exports.QueryNameRecordsRequest = exports.QueryGetRecordsByBondIdResponse = exports.QueryGetRecordsByBondIdRequest = exports.QueryGetRecordResponse = exports.QueryGetRecordRequest = exports.QueryRecordsResponse = exports.QueryRecordsRequest_KeyValueInput = exports.QueryRecordsRequest_ValueInput = exports.QueryRecordsRequest_MapInput_ValuesEntry = exports.QueryRecordsRequest_MapInput = exports.QueryRecordsRequest_ArrayInput = exports.QueryRecordsRequest = exports.QueryParamsResponse = exports.QueryParamsRequest = exports.protobufPackage = void 0;
/* eslint-disable */
const registry_1 = require("./registry");
const pagination_1 = require("../../../cosmos/base/query/v1beta1/pagination");
const long_1 = __importDefault(require("long"));
const coin_1 = require("../../../cosmos/base/v1beta1/coin");
const minimal_1 = __importDefault(require("protobufjs/minimal"));
exports.protobufPackage = "cerc.registry.v1";
function createBaseQueryParamsRequest() {
    return {};
}
exports.QueryParamsRequest = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryParamsRequest();
        return message;
    },
};
function createBaseQueryParamsResponse() {
    return { params: undefined };
}
exports.QueryParamsResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.params !== undefined) {
            registry_1.Params.encode(message.params, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.params = registry_1.Params.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            params: isSet(object.params) ? registry_1.Params.fromJSON(object.params) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.params !== undefined &&
            (obj.params = message.params ? registry_1.Params.toJSON(message.params) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryParamsResponse();
        message.params =
            object.params !== undefined && object.params !== null
                ? registry_1.Params.fromPartial(object.params)
                : undefined;
        return message;
    },
};
function createBaseQueryRecordsRequest() {
    return { attributes: [], all: false, pagination: undefined };
}
exports.QueryRecordsRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        for (const v of message.attributes) {
            exports.QueryRecordsRequest_KeyValueInput.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.all === true) {
            writer.uint32(16).bool(message.all);
        }
        if (message.pagination !== undefined) {
            pagination_1.PageRequest.encode(message.pagination, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryRecordsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.attributes.push(exports.QueryRecordsRequest_KeyValueInput.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.all = reader.bool();
                    break;
                case 3:
                    message.pagination = pagination_1.PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            attributes: Array.isArray(object === null || object === void 0 ? void 0 : object.attributes)
                ? object.attributes.map((e) => exports.QueryRecordsRequest_KeyValueInput.fromJSON(e))
                : [],
            all: isSet(object.all) ? Boolean(object.all) : false,
            pagination: isSet(object.pagination)
                ? pagination_1.PageRequest.fromJSON(object.pagination)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.attributes) {
            obj.attributes = message.attributes.map((e) => e ? exports.QueryRecordsRequest_KeyValueInput.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        message.all !== undefined && (obj.all = message.all);
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? pagination_1.PageRequest.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseQueryRecordsRequest();
        message.attributes =
            ((_a = object.attributes) === null || _a === void 0 ? void 0 : _a.map((e) => exports.QueryRecordsRequest_KeyValueInput.fromPartial(e))) || [];
        message.all = (_b = object.all) !== null && _b !== void 0 ? _b : false;
        message.pagination =
            object.pagination !== undefined && object.pagination !== null
                ? pagination_1.PageRequest.fromPartial(object.pagination)
                : undefined;
        return message;
    },
};
function createBaseQueryRecordsRequest_ArrayInput() {
    return { values: [] };
}
exports.QueryRecordsRequest_ArrayInput = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        for (const v of message.values) {
            exports.QueryRecordsRequest_ValueInput.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryRecordsRequest_ArrayInput();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.values.push(exports.QueryRecordsRequest_ValueInput.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            values: Array.isArray(object === null || object === void 0 ? void 0 : object.values)
                ? object.values.map((e) => exports.QueryRecordsRequest_ValueInput.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.values) {
            obj.values = message.values.map((e) => e ? exports.QueryRecordsRequest_ValueInput.toJSON(e) : undefined);
        }
        else {
            obj.values = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryRecordsRequest_ArrayInput();
        message.values =
            ((_a = object.values) === null || _a === void 0 ? void 0 : _a.map((e) => exports.QueryRecordsRequest_ValueInput.fromPartial(e))) || [];
        return message;
    },
};
function createBaseQueryRecordsRequest_MapInput() {
    return { values: {} };
}
exports.QueryRecordsRequest_MapInput = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        Object.entries(message.values).forEach(([key, value]) => {
            exports.QueryRecordsRequest_MapInput_ValuesEntry.encode({ key: key, value }, writer.uint32(10).fork()).ldelim();
        });
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryRecordsRequest_MapInput();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    const entry1 = exports.QueryRecordsRequest_MapInput_ValuesEntry.decode(reader, reader.uint32());
                    if (entry1.value !== undefined) {
                        message.values[entry1.key] = entry1.value;
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            values: isObject(object.values)
                ? Object.entries(object.values).reduce((acc, [key, value]) => {
                    acc[key] = exports.QueryRecordsRequest_ValueInput.fromJSON(value);
                    return acc;
                }, {})
                : {},
        };
    },
    toJSON(message) {
        const obj = {};
        obj.values = {};
        if (message.values) {
            Object.entries(message.values).forEach(([k, v]) => {
                obj.values[k] = exports.QueryRecordsRequest_ValueInput.toJSON(v);
            });
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryRecordsRequest_MapInput();
        message.values = Object.entries((_a = object.values) !== null && _a !== void 0 ? _a : {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = exports.QueryRecordsRequest_ValueInput.fromPartial(value);
            }
            return acc;
        }, {});
        return message;
    },
};
function createBaseQueryRecordsRequest_MapInput_ValuesEntry() {
    return { key: "", value: undefined };
}
exports.QueryRecordsRequest_MapInput_ValuesEntry = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.key !== "") {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            exports.QueryRecordsRequest_ValueInput.encode(message.value, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryRecordsRequest_MapInput_ValuesEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = exports.QueryRecordsRequest_ValueInput.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value)
                ? exports.QueryRecordsRequest_ValueInput.fromJSON(object.value)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined &&
            (obj.value = message.value
                ? exports.QueryRecordsRequest_ValueInput.toJSON(message.value)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryRecordsRequest_MapInput_ValuesEntry();
        message.key = (_a = object.key) !== null && _a !== void 0 ? _a : "";
        message.value =
            object.value !== undefined && object.value !== null
                ? exports.QueryRecordsRequest_ValueInput.fromPartial(object.value)
                : undefined;
        return message;
    },
};
function createBaseQueryRecordsRequest_ValueInput() {
    return {
        string: undefined,
        int: undefined,
        float: undefined,
        boolean: undefined,
        link: undefined,
        array: undefined,
        map: undefined,
    };
}
exports.QueryRecordsRequest_ValueInput = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.string !== undefined) {
            writer.uint32(10).string(message.string);
        }
        if (message.int !== undefined) {
            writer.uint32(16).int64(message.int);
        }
        if (message.float !== undefined) {
            writer.uint32(25).double(message.float);
        }
        if (message.boolean !== undefined) {
            writer.uint32(32).bool(message.boolean);
        }
        if (message.link !== undefined) {
            writer.uint32(42).string(message.link);
        }
        if (message.array !== undefined) {
            exports.QueryRecordsRequest_ArrayInput.encode(message.array, writer.uint32(50).fork()).ldelim();
        }
        if (message.map !== undefined) {
            exports.QueryRecordsRequest_MapInput.encode(message.map, writer.uint32(58).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryRecordsRequest_ValueInput();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.string = reader.string();
                    break;
                case 2:
                    message.int = reader.int64();
                    break;
                case 3:
                    message.float = reader.double();
                    break;
                case 4:
                    message.boolean = reader.bool();
                    break;
                case 5:
                    message.link = reader.string();
                    break;
                case 6:
                    message.array = exports.QueryRecordsRequest_ArrayInput.decode(reader, reader.uint32());
                    break;
                case 7:
                    message.map = exports.QueryRecordsRequest_MapInput.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            string: isSet(object.string) ? String(object.string) : undefined,
            int: isSet(object.int) ? long_1.default.fromValue(object.int) : undefined,
            float: isSet(object.float) ? Number(object.float) : undefined,
            boolean: isSet(object.boolean) ? Boolean(object.boolean) : undefined,
            link: isSet(object.link) ? String(object.link) : undefined,
            array: isSet(object.array)
                ? exports.QueryRecordsRequest_ArrayInput.fromJSON(object.array)
                : undefined,
            map: isSet(object.map)
                ? exports.QueryRecordsRequest_MapInput.fromJSON(object.map)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.string !== undefined && (obj.string = message.string);
        message.int !== undefined &&
            (obj.int = (message.int || undefined).toString());
        message.float !== undefined && (obj.float = message.float);
        message.boolean !== undefined && (obj.boolean = message.boolean);
        message.link !== undefined && (obj.link = message.link);
        message.array !== undefined &&
            (obj.array = message.array
                ? exports.QueryRecordsRequest_ArrayInput.toJSON(message.array)
                : undefined);
        message.map !== undefined &&
            (obj.map = message.map
                ? exports.QueryRecordsRequest_MapInput.toJSON(message.map)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d;
        const message = createBaseQueryRecordsRequest_ValueInput();
        message.string = (_a = object.string) !== null && _a !== void 0 ? _a : undefined;
        message.int =
            object.int !== undefined && object.int !== null
                ? long_1.default.fromValue(object.int)
                : undefined;
        message.float = (_b = object.float) !== null && _b !== void 0 ? _b : undefined;
        message.boolean = (_c = object.boolean) !== null && _c !== void 0 ? _c : undefined;
        message.link = (_d = object.link) !== null && _d !== void 0 ? _d : undefined;
        message.array =
            object.array !== undefined && object.array !== null
                ? exports.QueryRecordsRequest_ArrayInput.fromPartial(object.array)
                : undefined;
        message.map =
            object.map !== undefined && object.map !== null
                ? exports.QueryRecordsRequest_MapInput.fromPartial(object.map)
                : undefined;
        return message;
    },
};
function createBaseQueryRecordsRequest_KeyValueInput() {
    return { key: "", value: undefined };
}
exports.QueryRecordsRequest_KeyValueInput = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.key !== "") {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            exports.QueryRecordsRequest_ValueInput.encode(message.value, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryRecordsRequest_KeyValueInput();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = exports.QueryRecordsRequest_ValueInput.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value)
                ? exports.QueryRecordsRequest_ValueInput.fromJSON(object.value)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined &&
            (obj.value = message.value
                ? exports.QueryRecordsRequest_ValueInput.toJSON(message.value)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryRecordsRequest_KeyValueInput();
        message.key = (_a = object.key) !== null && _a !== void 0 ? _a : "";
        message.value =
            object.value !== undefined && object.value !== null
                ? exports.QueryRecordsRequest_ValueInput.fromPartial(object.value)
                : undefined;
        return message;
    },
};
function createBaseQueryRecordsResponse() {
    return { records: [], pagination: undefined };
}
exports.QueryRecordsResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        for (const v of message.records) {
            registry_1.Record.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            pagination_1.PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryRecordsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.records.push(registry_1.Record.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = pagination_1.PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            records: Array.isArray(object === null || object === void 0 ? void 0 : object.records)
                ? object.records.map((e) => registry_1.Record.fromJSON(e))
                : [],
            pagination: isSet(object.pagination)
                ? pagination_1.PageResponse.fromJSON(object.pagination)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.records) {
            obj.records = message.records.map((e) => e ? registry_1.Record.toJSON(e) : undefined);
        }
        else {
            obj.records = [];
        }
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? pagination_1.PageResponse.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryRecordsResponse();
        message.records = ((_a = object.records) === null || _a === void 0 ? void 0 : _a.map((e) => registry_1.Record.fromPartial(e))) || [];
        message.pagination =
            object.pagination !== undefined && object.pagination !== null
                ? pagination_1.PageResponse.fromPartial(object.pagination)
                : undefined;
        return message;
    },
};
function createBaseQueryGetRecordRequest() {
    return { id: "" };
}
exports.QueryGetRecordRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetRecordRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryGetRecordRequest();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseQueryGetRecordResponse() {
    return { record: undefined };
}
exports.QueryGetRecordResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.record !== undefined) {
            registry_1.Record.encode(message.record, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetRecordResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.record = registry_1.Record.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            record: isSet(object.record) ? registry_1.Record.fromJSON(object.record) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.record !== undefined &&
            (obj.record = message.record ? registry_1.Record.toJSON(message.record) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryGetRecordResponse();
        message.record =
            object.record !== undefined && object.record !== null
                ? registry_1.Record.fromPartial(object.record)
                : undefined;
        return message;
    },
};
function createBaseQueryGetRecordsByBondIdRequest() {
    return { id: "", pagination: undefined };
}
exports.QueryGetRecordsByBondIdRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        if (message.pagination !== undefined) {
            pagination_1.PageRequest.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetRecordsByBondIdRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.pagination = pagination_1.PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
            pagination: isSet(object.pagination)
                ? pagination_1.PageRequest.fromJSON(object.pagination)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? pagination_1.PageRequest.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryGetRecordsByBondIdRequest();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : "";
        message.pagination =
            object.pagination !== undefined && object.pagination !== null
                ? pagination_1.PageRequest.fromPartial(object.pagination)
                : undefined;
        return message;
    },
};
function createBaseQueryGetRecordsByBondIdResponse() {
    return { records: [], pagination: undefined };
}
exports.QueryGetRecordsByBondIdResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        for (const v of message.records) {
            registry_1.Record.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            pagination_1.PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetRecordsByBondIdResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.records.push(registry_1.Record.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = pagination_1.PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            records: Array.isArray(object === null || object === void 0 ? void 0 : object.records)
                ? object.records.map((e) => registry_1.Record.fromJSON(e))
                : [],
            pagination: isSet(object.pagination)
                ? pagination_1.PageResponse.fromJSON(object.pagination)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.records) {
            obj.records = message.records.map((e) => e ? registry_1.Record.toJSON(e) : undefined);
        }
        else {
            obj.records = [];
        }
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? pagination_1.PageResponse.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryGetRecordsByBondIdResponse();
        message.records = ((_a = object.records) === null || _a === void 0 ? void 0 : _a.map((e) => registry_1.Record.fromPartial(e))) || [];
        message.pagination =
            object.pagination !== undefined && object.pagination !== null
                ? pagination_1.PageResponse.fromPartial(object.pagination)
                : undefined;
        return message;
    },
};
function createBaseQueryNameRecordsRequest() {
    return { pagination: undefined };
}
exports.QueryNameRecordsRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.pagination !== undefined) {
            pagination_1.PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryNameRecordsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = pagination_1.PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            pagination: isSet(object.pagination)
                ? pagination_1.PageRequest.fromJSON(object.pagination)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? pagination_1.PageRequest.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryNameRecordsRequest();
        message.pagination =
            object.pagination !== undefined && object.pagination !== null
                ? pagination_1.PageRequest.fromPartial(object.pagination)
                : undefined;
        return message;
    },
};
function createBaseQueryNameRecordsResponse() {
    return { names: [], pagination: undefined };
}
exports.QueryNameRecordsResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        for (const v of message.names) {
            registry_1.NameEntry.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            pagination_1.PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryNameRecordsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.names.push(registry_1.NameEntry.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = pagination_1.PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            names: Array.isArray(object === null || object === void 0 ? void 0 : object.names)
                ? object.names.map((e) => registry_1.NameEntry.fromJSON(e))
                : [],
            pagination: isSet(object.pagination)
                ? pagination_1.PageResponse.fromJSON(object.pagination)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.names) {
            obj.names = message.names.map((e) => e ? registry_1.NameEntry.toJSON(e) : undefined);
        }
        else {
            obj.names = [];
        }
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? pagination_1.PageResponse.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryNameRecordsResponse();
        message.names = ((_a = object.names) === null || _a === void 0 ? void 0 : _a.map((e) => registry_1.NameEntry.fromPartial(e))) || [];
        message.pagination =
            object.pagination !== undefined && object.pagination !== null
                ? pagination_1.PageResponse.fromPartial(object.pagination)
                : undefined;
        return message;
    },
};
function createBaseQueryWhoisRequest() {
    return { name: "" };
}
exports.QueryWhoisRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.name !== "") {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryWhoisRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryWhoisRequest();
        message.name = (_a = object.name) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseQueryWhoisResponse() {
    return { nameAuthority: undefined };
}
exports.QueryWhoisResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.nameAuthority !== undefined) {
            registry_1.NameAuthority.encode(message.nameAuthority, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryWhoisResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.nameAuthority = registry_1.NameAuthority.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            nameAuthority: isSet(object.nameAuthority)
                ? registry_1.NameAuthority.fromJSON(object.nameAuthority)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.nameAuthority !== undefined &&
            (obj.nameAuthority = message.nameAuthority
                ? registry_1.NameAuthority.toJSON(message.nameAuthority)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryWhoisResponse();
        message.nameAuthority =
            object.nameAuthority !== undefined && object.nameAuthority !== null
                ? registry_1.NameAuthority.fromPartial(object.nameAuthority)
                : undefined;
        return message;
    },
};
function createBaseQueryAuthoritiesRequest() {
    return { owner: "" };
}
exports.QueryAuthoritiesRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.owner !== "") {
            writer.uint32(10).string(message.owner);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAuthoritiesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryAuthoritiesRequest();
        message.owner = (_a = object.owner) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseQueryAuthoritiesResponse() {
    return { authorities: [], pagination: undefined };
}
exports.QueryAuthoritiesResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        for (const v of message.authorities) {
            registry_1.AuthorityEntry.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            pagination_1.PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAuthoritiesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.authorities.push(registry_1.AuthorityEntry.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = pagination_1.PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            authorities: Array.isArray(object === null || object === void 0 ? void 0 : object.authorities)
                ? object.authorities.map((e) => registry_1.AuthorityEntry.fromJSON(e))
                : [],
            pagination: isSet(object.pagination)
                ? pagination_1.PageResponse.fromJSON(object.pagination)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.authorities) {
            obj.authorities = message.authorities.map((e) => e ? registry_1.AuthorityEntry.toJSON(e) : undefined);
        }
        else {
            obj.authorities = [];
        }
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? pagination_1.PageResponse.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryAuthoritiesResponse();
        message.authorities =
            ((_a = object.authorities) === null || _a === void 0 ? void 0 : _a.map((e) => registry_1.AuthorityEntry.fromPartial(e))) || [];
        message.pagination =
            object.pagination !== undefined && object.pagination !== null
                ? pagination_1.PageResponse.fromPartial(object.pagination)
                : undefined;
        return message;
    },
};
function createBaseQueryLookupLrnRequest() {
    return { lrn: "" };
}
exports.QueryLookupLrnRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.lrn !== "") {
            writer.uint32(10).string(message.lrn);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryLookupLrnRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.lrn = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            lrn: isSet(object.lrn) ? String(object.lrn) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.lrn !== undefined && (obj.lrn = message.lrn);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryLookupLrnRequest();
        message.lrn = (_a = object.lrn) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseQueryLookupLrnResponse() {
    return { name: undefined };
}
exports.QueryLookupLrnResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.name !== undefined) {
            registry_1.NameRecord.encode(message.name, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryLookupLrnResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = registry_1.NameRecord.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            name: isSet(object.name) ? registry_1.NameRecord.fromJSON(object.name) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined &&
            (obj.name = message.name ? registry_1.NameRecord.toJSON(message.name) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryLookupLrnResponse();
        message.name =
            object.name !== undefined && object.name !== null
                ? registry_1.NameRecord.fromPartial(object.name)
                : undefined;
        return message;
    },
};
function createBaseQueryResolveLrnRequest() {
    return { lrn: "" };
}
exports.QueryResolveLrnRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.lrn !== "") {
            writer.uint32(10).string(message.lrn);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryResolveLrnRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.lrn = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            lrn: isSet(object.lrn) ? String(object.lrn) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.lrn !== undefined && (obj.lrn = message.lrn);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryResolveLrnRequest();
        message.lrn = (_a = object.lrn) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseQueryResolveLrnResponse() {
    return { record: undefined };
}
exports.QueryResolveLrnResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.record !== undefined) {
            registry_1.Record.encode(message.record, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryResolveLrnResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.record = registry_1.Record.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            record: isSet(object.record) ? registry_1.Record.fromJSON(object.record) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.record !== undefined &&
            (obj.record = message.record ? registry_1.Record.toJSON(message.record) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryResolveLrnResponse();
        message.record =
            object.record !== undefined && object.record !== null
                ? registry_1.Record.fromPartial(object.record)
                : undefined;
        return message;
    },
};
function createBaseQueryGetRegistryModuleBalanceRequest() {
    return {};
}
exports.QueryGetRegistryModuleBalanceRequest = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetRegistryModuleBalanceRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryGetRegistryModuleBalanceRequest();
        return message;
    },
};
function createBaseQueryGetRegistryModuleBalanceResponse() {
    return { balances: [] };
}
exports.QueryGetRegistryModuleBalanceResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        for (const v of message.balances) {
            exports.AccountBalance.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetRegistryModuleBalanceResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.balances.push(exports.AccountBalance.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            balances: Array.isArray(object === null || object === void 0 ? void 0 : object.balances)
                ? object.balances.map((e) => exports.AccountBalance.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.balances) {
            obj.balances = message.balances.map((e) => e ? exports.AccountBalance.toJSON(e) : undefined);
        }
        else {
            obj.balances = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryGetRegistryModuleBalanceResponse();
        message.balances =
            ((_a = object.balances) === null || _a === void 0 ? void 0 : _a.map((e) => exports.AccountBalance.fromPartial(e))) || [];
        return message;
    },
};
function createBaseAccountBalance() {
    return { accountName: "", balance: [] };
}
exports.AccountBalance = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.accountName !== "") {
            writer.uint32(10).string(message.accountName);
        }
        for (const v of message.balance) {
            coin_1.Coin.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAccountBalance();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.accountName = reader.string();
                    break;
                case 3:
                    message.balance.push(coin_1.Coin.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            accountName: isSet(object.accountName) ? String(object.accountName) : "",
            balance: Array.isArray(object === null || object === void 0 ? void 0 : object.balance)
                ? object.balance.map((e) => coin_1.Coin.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.accountName !== undefined &&
            (obj.accountName = message.accountName);
        if (message.balance) {
            obj.balance = message.balance.map((e) => e ? coin_1.Coin.toJSON(e) : undefined);
        }
        else {
            obj.balance = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseAccountBalance();
        message.accountName = (_a = object.accountName) !== null && _a !== void 0 ? _a : "";
        message.balance = ((_b = object.balance) === null || _b === void 0 ? void 0 : _b.map((e) => coin_1.Coin.fromPartial(e))) || [];
        return message;
    },
};
class QueryClientImpl {
    constructor(rpc) {
        this.rpc = rpc;
        this.Params = this.Params.bind(this);
        this.Records = this.Records.bind(this);
        this.GetRecord = this.GetRecord.bind(this);
        this.GetRecordsByBondId = this.GetRecordsByBondId.bind(this);
        this.NameRecords = this.NameRecords.bind(this);
        this.Whois = this.Whois.bind(this);
        this.LookupLrn = this.LookupLrn.bind(this);
        this.ResolveLrn = this.ResolveLrn.bind(this);
        this.GetRegistryModuleBalance = this.GetRegistryModuleBalance.bind(this);
        this.Authorities = this.Authorities.bind(this);
    }
    Params(request) {
        const data = exports.QueryParamsRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Query", "Params", data);
        return promise.then((data) => exports.QueryParamsResponse.decode(new minimal_1.default.Reader(data)));
    }
    Records(request) {
        const data = exports.QueryRecordsRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Query", "Records", data);
        return promise.then((data) => exports.QueryRecordsResponse.decode(new minimal_1.default.Reader(data)));
    }
    GetRecord(request) {
        const data = exports.QueryGetRecordRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Query", "GetRecord", data);
        return promise.then((data) => exports.QueryGetRecordResponse.decode(new minimal_1.default.Reader(data)));
    }
    GetRecordsByBondId(request) {
        const data = exports.QueryGetRecordsByBondIdRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Query", "GetRecordsByBondId", data);
        return promise.then((data) => exports.QueryGetRecordsByBondIdResponse.decode(new minimal_1.default.Reader(data)));
    }
    NameRecords(request) {
        const data = exports.QueryNameRecordsRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Query", "NameRecords", data);
        return promise.then((data) => exports.QueryNameRecordsResponse.decode(new minimal_1.default.Reader(data)));
    }
    Whois(request) {
        const data = exports.QueryWhoisRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Query", "Whois", data);
        return promise.then((data) => exports.QueryWhoisResponse.decode(new minimal_1.default.Reader(data)));
    }
    LookupLrn(request) {
        const data = exports.QueryLookupLrnRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Query", "LookupLrn", data);
        return promise.then((data) => exports.QueryLookupLrnResponse.decode(new minimal_1.default.Reader(data)));
    }
    ResolveLrn(request) {
        const data = exports.QueryResolveLrnRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Query", "ResolveLrn", data);
        return promise.then((data) => exports.QueryResolveLrnResponse.decode(new minimal_1.default.Reader(data)));
    }
    GetRegistryModuleBalance(request) {
        const data = exports.QueryGetRegistryModuleBalanceRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Query", "GetRegistryModuleBalance", data);
        return promise.then((data) => exports.QueryGetRegistryModuleBalanceResponse.decode(new minimal_1.default.Reader(data)));
    }
    Authorities(request) {
        const data = exports.QueryAuthoritiesRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Query", "Authorities", data);
        return promise.then((data) => exports.QueryAuthoritiesResponse.decode(new minimal_1.default.Reader(data)));
    }
}
exports.QueryClientImpl = QueryClientImpl;
if (minimal_1.default.util.Long !== long_1.default) {
    minimal_1.default.util.Long = long_1.default;
    minimal_1.default.configure();
}
function isObject(value) {
    return typeof value === "object" && value !== null;
}
function isSet(value) {
    return value !== null && value !== undefined;
}
