"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RecordsList = exports.ExpiryQueue = exports.Signature = exports.NameRecordEntry = exports.NameRecord = exports.NameEntry = exports.NameAuthority = exports.AuthorityEntry = exports.Record = exports.Params = exports.protobufPackage = void 0;
/* eslint-disable */
const coin_1 = require("../../../cosmos/base/v1beta1/coin");
const duration_1 = require("../../../google/protobuf/duration");
const timestamp_1 = require("../../../google/protobuf/timestamp");
const long_1 = __importDefault(require("long"));
const minimal_1 = __importDefault(require("protobufjs/minimal"));
exports.protobufPackage = "cerc.registry.v1";
function createBaseParams() {
    return {
        recordRent: undefined,
        recordRentDuration: undefined,
        authorityRent: undefined,
        authorityRentDuration: undefined,
        authorityGracePeriod: undefined,
        authorityAuctionEnabled: false,
        authorityAuctionCommitsDuration: undefined,
        authorityAuctionRevealsDuration: undefined,
        authorityAuctionCommitFee: undefined,
        authorityAuctionRevealFee: undefined,
        authorityAuctionMinimumBid: undefined,
    };
}
exports.Params = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.recordRent !== undefined) {
            coin_1.Coin.encode(message.recordRent, writer.uint32(10).fork()).ldelim();
        }
        if (message.recordRentDuration !== undefined) {
            duration_1.Duration.encode(message.recordRentDuration, writer.uint32(18).fork()).ldelim();
        }
        if (message.authorityRent !== undefined) {
            coin_1.Coin.encode(message.authorityRent, writer.uint32(26).fork()).ldelim();
        }
        if (message.authorityRentDuration !== undefined) {
            duration_1.Duration.encode(message.authorityRentDuration, writer.uint32(34).fork()).ldelim();
        }
        if (message.authorityGracePeriod !== undefined) {
            duration_1.Duration.encode(message.authorityGracePeriod, writer.uint32(42).fork()).ldelim();
        }
        if (message.authorityAuctionEnabled === true) {
            writer.uint32(48).bool(message.authorityAuctionEnabled);
        }
        if (message.authorityAuctionCommitsDuration !== undefined) {
            duration_1.Duration.encode(message.authorityAuctionCommitsDuration, writer.uint32(58).fork()).ldelim();
        }
        if (message.authorityAuctionRevealsDuration !== undefined) {
            duration_1.Duration.encode(message.authorityAuctionRevealsDuration, writer.uint32(66).fork()).ldelim();
        }
        if (message.authorityAuctionCommitFee !== undefined) {
            coin_1.Coin.encode(message.authorityAuctionCommitFee, writer.uint32(74).fork()).ldelim();
        }
        if (message.authorityAuctionRevealFee !== undefined) {
            coin_1.Coin.encode(message.authorityAuctionRevealFee, writer.uint32(82).fork()).ldelim();
        }
        if (message.authorityAuctionMinimumBid !== undefined) {
            coin_1.Coin.encode(message.authorityAuctionMinimumBid, writer.uint32(90).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParams();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.recordRent = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.recordRentDuration = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.authorityRent = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.authorityRentDuration = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.authorityGracePeriod = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.authorityAuctionEnabled = reader.bool();
                    break;
                case 7:
                    message.authorityAuctionCommitsDuration = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                case 8:
                    message.authorityAuctionRevealsDuration = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                case 9:
                    message.authorityAuctionCommitFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 10:
                    message.authorityAuctionRevealFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 11:
                    message.authorityAuctionMinimumBid = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            recordRent: isSet(object.recordRent)
                ? coin_1.Coin.fromJSON(object.recordRent)
                : undefined,
            recordRentDuration: isSet(object.recordRentDuration)
                ? duration_1.Duration.fromJSON(object.recordRentDuration)
                : undefined,
            authorityRent: isSet(object.authorityRent)
                ? coin_1.Coin.fromJSON(object.authorityRent)
                : undefined,
            authorityRentDuration: isSet(object.authorityRentDuration)
                ? duration_1.Duration.fromJSON(object.authorityRentDuration)
                : undefined,
            authorityGracePeriod: isSet(object.authorityGracePeriod)
                ? duration_1.Duration.fromJSON(object.authorityGracePeriod)
                : undefined,
            authorityAuctionEnabled: isSet(object.authorityAuctionEnabled)
                ? Boolean(object.authorityAuctionEnabled)
                : false,
            authorityAuctionCommitsDuration: isSet(object.authorityAuctionCommitsDuration)
                ? duration_1.Duration.fromJSON(object.authorityAuctionCommitsDuration)
                : undefined,
            authorityAuctionRevealsDuration: isSet(object.authorityAuctionRevealsDuration)
                ? duration_1.Duration.fromJSON(object.authorityAuctionRevealsDuration)
                : undefined,
            authorityAuctionCommitFee: isSet(object.authorityAuctionCommitFee)
                ? coin_1.Coin.fromJSON(object.authorityAuctionCommitFee)
                : undefined,
            authorityAuctionRevealFee: isSet(object.authorityAuctionRevealFee)
                ? coin_1.Coin.fromJSON(object.authorityAuctionRevealFee)
                : undefined,
            authorityAuctionMinimumBid: isSet(object.authorityAuctionMinimumBid)
                ? coin_1.Coin.fromJSON(object.authorityAuctionMinimumBid)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.recordRent !== undefined &&
            (obj.recordRent = message.recordRent
                ? coin_1.Coin.toJSON(message.recordRent)
                : undefined);
        message.recordRentDuration !== undefined &&
            (obj.recordRentDuration = message.recordRentDuration
                ? duration_1.Duration.toJSON(message.recordRentDuration)
                : undefined);
        message.authorityRent !== undefined &&
            (obj.authorityRent = message.authorityRent
                ? coin_1.Coin.toJSON(message.authorityRent)
                : undefined);
        message.authorityRentDuration !== undefined &&
            (obj.authorityRentDuration = message.authorityRentDuration
                ? duration_1.Duration.toJSON(message.authorityRentDuration)
                : undefined);
        message.authorityGracePeriod !== undefined &&
            (obj.authorityGracePeriod = message.authorityGracePeriod
                ? duration_1.Duration.toJSON(message.authorityGracePeriod)
                : undefined);
        message.authorityAuctionEnabled !== undefined &&
            (obj.authorityAuctionEnabled = message.authorityAuctionEnabled);
        message.authorityAuctionCommitsDuration !== undefined &&
            (obj.authorityAuctionCommitsDuration =
                message.authorityAuctionCommitsDuration
                    ? duration_1.Duration.toJSON(message.authorityAuctionCommitsDuration)
                    : undefined);
        message.authorityAuctionRevealsDuration !== undefined &&
            (obj.authorityAuctionRevealsDuration =
                message.authorityAuctionRevealsDuration
                    ? duration_1.Duration.toJSON(message.authorityAuctionRevealsDuration)
                    : undefined);
        message.authorityAuctionCommitFee !== undefined &&
            (obj.authorityAuctionCommitFee = message.authorityAuctionCommitFee
                ? coin_1.Coin.toJSON(message.authorityAuctionCommitFee)
                : undefined);
        message.authorityAuctionRevealFee !== undefined &&
            (obj.authorityAuctionRevealFee = message.authorityAuctionRevealFee
                ? coin_1.Coin.toJSON(message.authorityAuctionRevealFee)
                : undefined);
        message.authorityAuctionMinimumBid !== undefined &&
            (obj.authorityAuctionMinimumBid = message.authorityAuctionMinimumBid
                ? coin_1.Coin.toJSON(message.authorityAuctionMinimumBid)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseParams();
        message.recordRent =
            object.recordRent !== undefined && object.recordRent !== null
                ? coin_1.Coin.fromPartial(object.recordRent)
                : undefined;
        message.recordRentDuration =
            object.recordRentDuration !== undefined &&
                object.recordRentDuration !== null
                ? duration_1.Duration.fromPartial(object.recordRentDuration)
                : undefined;
        message.authorityRent =
            object.authorityRent !== undefined && object.authorityRent !== null
                ? coin_1.Coin.fromPartial(object.authorityRent)
                : undefined;
        message.authorityRentDuration =
            object.authorityRentDuration !== undefined &&
                object.authorityRentDuration !== null
                ? duration_1.Duration.fromPartial(object.authorityRentDuration)
                : undefined;
        message.authorityGracePeriod =
            object.authorityGracePeriod !== undefined &&
                object.authorityGracePeriod !== null
                ? duration_1.Duration.fromPartial(object.authorityGracePeriod)
                : undefined;
        message.authorityAuctionEnabled = (_a = object.authorityAuctionEnabled) !== null && _a !== void 0 ? _a : false;
        message.authorityAuctionCommitsDuration =
            object.authorityAuctionCommitsDuration !== undefined &&
                object.authorityAuctionCommitsDuration !== null
                ? duration_1.Duration.fromPartial(object.authorityAuctionCommitsDuration)
                : undefined;
        message.authorityAuctionRevealsDuration =
            object.authorityAuctionRevealsDuration !== undefined &&
                object.authorityAuctionRevealsDuration !== null
                ? duration_1.Duration.fromPartial(object.authorityAuctionRevealsDuration)
                : undefined;
        message.authorityAuctionCommitFee =
            object.authorityAuctionCommitFee !== undefined &&
                object.authorityAuctionCommitFee !== null
                ? coin_1.Coin.fromPartial(object.authorityAuctionCommitFee)
                : undefined;
        message.authorityAuctionRevealFee =
            object.authorityAuctionRevealFee !== undefined &&
                object.authorityAuctionRevealFee !== null
                ? coin_1.Coin.fromPartial(object.authorityAuctionRevealFee)
                : undefined;
        message.authorityAuctionMinimumBid =
            object.authorityAuctionMinimumBid !== undefined &&
                object.authorityAuctionMinimumBid !== null
                ? coin_1.Coin.fromPartial(object.authorityAuctionMinimumBid)
                : undefined;
        return message;
    },
};
function createBaseRecord() {
    return {
        id: "",
        bondId: "",
        createTime: "",
        expiryTime: "",
        deleted: false,
        owners: [],
        attributes: new Uint8Array(),
        names: [],
        type: "",
    };
}
exports.Record = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        if (message.bondId !== "") {
            writer.uint32(18).string(message.bondId);
        }
        if (message.createTime !== "") {
            writer.uint32(26).string(message.createTime);
        }
        if (message.expiryTime !== "") {
            writer.uint32(34).string(message.expiryTime);
        }
        if (message.deleted === true) {
            writer.uint32(40).bool(message.deleted);
        }
        for (const v of message.owners) {
            writer.uint32(50).string(v);
        }
        if (message.attributes.length !== 0) {
            writer.uint32(58).bytes(message.attributes);
        }
        for (const v of message.names) {
            writer.uint32(66).string(v);
        }
        if (message.type !== "") {
            writer.uint32(74).string(message.type);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRecord();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.bondId = reader.string();
                    break;
                case 3:
                    message.createTime = reader.string();
                    break;
                case 4:
                    message.expiryTime = reader.string();
                    break;
                case 5:
                    message.deleted = reader.bool();
                    break;
                case 6:
                    message.owners.push(reader.string());
                    break;
                case 7:
                    message.attributes = reader.bytes();
                    break;
                case 8:
                    message.names.push(reader.string());
                    break;
                case 9:
                    message.type = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
            bondId: isSet(object.bondId) ? String(object.bondId) : "",
            createTime: isSet(object.createTime) ? String(object.createTime) : "",
            expiryTime: isSet(object.expiryTime) ? String(object.expiryTime) : "",
            deleted: isSet(object.deleted) ? Boolean(object.deleted) : false,
            owners: Array.isArray(object === null || object === void 0 ? void 0 : object.owners)
                ? object.owners.map((e) => String(e))
                : [],
            attributes: isSet(object.attributes)
                ? bytesFromBase64(object.attributes)
                : new Uint8Array(),
            names: Array.isArray(object === null || object === void 0 ? void 0 : object.names)
                ? object.names.map((e) => String(e))
                : [],
            type: isSet(object.type) ? String(object.type) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        message.bondId !== undefined && (obj.bondId = message.bondId);
        message.createTime !== undefined && (obj.createTime = message.createTime);
        message.expiryTime !== undefined && (obj.expiryTime = message.expiryTime);
        message.deleted !== undefined && (obj.deleted = message.deleted);
        if (message.owners) {
            obj.owners = message.owners.map((e) => e);
        }
        else {
            obj.owners = [];
        }
        message.attributes !== undefined &&
            (obj.attributes = base64FromBytes(message.attributes !== undefined ? message.attributes : new Uint8Array()));
        if (message.names) {
            obj.names = message.names.map((e) => e);
        }
        else {
            obj.names = [];
        }
        message.type !== undefined && (obj.type = message.type);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j;
        const message = createBaseRecord();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : "";
        message.bondId = (_b = object.bondId) !== null && _b !== void 0 ? _b : "";
        message.createTime = (_c = object.createTime) !== null && _c !== void 0 ? _c : "";
        message.expiryTime = (_d = object.expiryTime) !== null && _d !== void 0 ? _d : "";
        message.deleted = (_e = object.deleted) !== null && _e !== void 0 ? _e : false;
        message.owners = ((_f = object.owners) === null || _f === void 0 ? void 0 : _f.map((e) => e)) || [];
        message.attributes = (_g = object.attributes) !== null && _g !== void 0 ? _g : new Uint8Array();
        message.names = ((_h = object.names) === null || _h === void 0 ? void 0 : _h.map((e) => e)) || [];
        message.type = (_j = object.type) !== null && _j !== void 0 ? _j : "";
        return message;
    },
};
function createBaseAuthorityEntry() {
    return { name: "", entry: undefined };
}
exports.AuthorityEntry = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.name !== "") {
            writer.uint32(10).string(message.name);
        }
        if (message.entry !== undefined) {
            exports.NameAuthority.encode(message.entry, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAuthorityEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.entry = exports.NameAuthority.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            entry: isSet(object.entry)
                ? exports.NameAuthority.fromJSON(object.entry)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.entry !== undefined &&
            (obj.entry = message.entry
                ? exports.NameAuthority.toJSON(message.entry)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseAuthorityEntry();
        message.name = (_a = object.name) !== null && _a !== void 0 ? _a : "";
        message.entry =
            object.entry !== undefined && object.entry !== null
                ? exports.NameAuthority.fromPartial(object.entry)
                : undefined;
        return message;
    },
};
function createBaseNameAuthority() {
    return {
        ownerPublicKey: "",
        ownerAddress: "",
        height: long_1.default.UZERO,
        status: "",
        auctionId: "",
        bondId: "",
        expiryTime: undefined,
    };
}
exports.NameAuthority = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.ownerPublicKey !== "") {
            writer.uint32(10).string(message.ownerPublicKey);
        }
        if (message.ownerAddress !== "") {
            writer.uint32(18).string(message.ownerAddress);
        }
        if (!message.height.isZero()) {
            writer.uint32(24).uint64(message.height);
        }
        if (message.status !== "") {
            writer.uint32(34).string(message.status);
        }
        if (message.auctionId !== "") {
            writer.uint32(42).string(message.auctionId);
        }
        if (message.bondId !== "") {
            writer.uint32(50).string(message.bondId);
        }
        if (message.expiryTime !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.expiryTime), writer.uint32(58).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseNameAuthority();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.ownerPublicKey = reader.string();
                    break;
                case 2:
                    message.ownerAddress = reader.string();
                    break;
                case 3:
                    message.height = reader.uint64();
                    break;
                case 4:
                    message.status = reader.string();
                    break;
                case 5:
                    message.auctionId = reader.string();
                    break;
                case 6:
                    message.bondId = reader.string();
                    break;
                case 7:
                    message.expiryTime = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            ownerPublicKey: isSet(object.ownerPublicKey)
                ? String(object.ownerPublicKey)
                : "",
            ownerAddress: isSet(object.ownerAddress)
                ? String(object.ownerAddress)
                : "",
            height: isSet(object.height) ? long_1.default.fromValue(object.height) : long_1.default.UZERO,
            status: isSet(object.status) ? String(object.status) : "",
            auctionId: isSet(object.auctionId) ? String(object.auctionId) : "",
            bondId: isSet(object.bondId) ? String(object.bondId) : "",
            expiryTime: isSet(object.expiryTime)
                ? fromJsonTimestamp(object.expiryTime)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.ownerPublicKey !== undefined &&
            (obj.ownerPublicKey = message.ownerPublicKey);
        message.ownerAddress !== undefined &&
            (obj.ownerAddress = message.ownerAddress);
        message.height !== undefined &&
            (obj.height = (message.height || long_1.default.UZERO).toString());
        message.status !== undefined && (obj.status = message.status);
        message.auctionId !== undefined && (obj.auctionId = message.auctionId);
        message.bondId !== undefined && (obj.bondId = message.bondId);
        message.expiryTime !== undefined &&
            (obj.expiryTime = message.expiryTime.toISOString());
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f;
        const message = createBaseNameAuthority();
        message.ownerPublicKey = (_a = object.ownerPublicKey) !== null && _a !== void 0 ? _a : "";
        message.ownerAddress = (_b = object.ownerAddress) !== null && _b !== void 0 ? _b : "";
        message.height =
            object.height !== undefined && object.height !== null
                ? long_1.default.fromValue(object.height)
                : long_1.default.UZERO;
        message.status = (_c = object.status) !== null && _c !== void 0 ? _c : "";
        message.auctionId = (_d = object.auctionId) !== null && _d !== void 0 ? _d : "";
        message.bondId = (_e = object.bondId) !== null && _e !== void 0 ? _e : "";
        message.expiryTime = (_f = object.expiryTime) !== null && _f !== void 0 ? _f : undefined;
        return message;
    },
};
function createBaseNameEntry() {
    return { name: "", entry: undefined };
}
exports.NameEntry = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.name !== "") {
            writer.uint32(10).string(message.name);
        }
        if (message.entry !== undefined) {
            exports.NameRecord.encode(message.entry, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseNameEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.entry = exports.NameRecord.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            entry: isSet(object.entry)
                ? exports.NameRecord.fromJSON(object.entry)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.entry !== undefined &&
            (obj.entry = message.entry
                ? exports.NameRecord.toJSON(message.entry)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseNameEntry();
        message.name = (_a = object.name) !== null && _a !== void 0 ? _a : "";
        message.entry =
            object.entry !== undefined && object.entry !== null
                ? exports.NameRecord.fromPartial(object.entry)
                : undefined;
        return message;
    },
};
function createBaseNameRecord() {
    return { latest: undefined, history: [] };
}
exports.NameRecord = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.latest !== undefined) {
            exports.NameRecordEntry.encode(message.latest, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.history) {
            exports.NameRecordEntry.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseNameRecord();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.latest = exports.NameRecordEntry.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.history.push(exports.NameRecordEntry.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            latest: isSet(object.latest)
                ? exports.NameRecordEntry.fromJSON(object.latest)
                : undefined,
            history: Array.isArray(object === null || object === void 0 ? void 0 : object.history)
                ? object.history.map((e) => exports.NameRecordEntry.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.latest !== undefined &&
            (obj.latest = message.latest
                ? exports.NameRecordEntry.toJSON(message.latest)
                : undefined);
        if (message.history) {
            obj.history = message.history.map((e) => e ? exports.NameRecordEntry.toJSON(e) : undefined);
        }
        else {
            obj.history = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseNameRecord();
        message.latest =
            object.latest !== undefined && object.latest !== null
                ? exports.NameRecordEntry.fromPartial(object.latest)
                : undefined;
        message.history =
            ((_a = object.history) === null || _a === void 0 ? void 0 : _a.map((e) => exports.NameRecordEntry.fromPartial(e))) || [];
        return message;
    },
};
function createBaseNameRecordEntry() {
    return { id: "", height: long_1.default.UZERO };
}
exports.NameRecordEntry = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        if (!message.height.isZero()) {
            writer.uint32(16).uint64(message.height);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseNameRecordEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.height = reader.uint64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
            height: isSet(object.height) ? long_1.default.fromValue(object.height) : long_1.default.UZERO,
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        message.height !== undefined &&
            (obj.height = (message.height || long_1.default.UZERO).toString());
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseNameRecordEntry();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : "";
        message.height =
            object.height !== undefined && object.height !== null
                ? long_1.default.fromValue(object.height)
                : long_1.default.UZERO;
        return message;
    },
};
function createBaseSignature() {
    return { sig: "", pubKey: "" };
}
exports.Signature = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.sig !== "") {
            writer.uint32(10).string(message.sig);
        }
        if (message.pubKey !== "") {
            writer.uint32(18).string(message.pubKey);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSignature();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.sig = reader.string();
                    break;
                case 2:
                    message.pubKey = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            sig: isSet(object.sig) ? String(object.sig) : "",
            pubKey: isSet(object.pubKey) ? String(object.pubKey) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.sig !== undefined && (obj.sig = message.sig);
        message.pubKey !== undefined && (obj.pubKey = message.pubKey);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseSignature();
        message.sig = (_a = object.sig) !== null && _a !== void 0 ? _a : "";
        message.pubKey = (_b = object.pubKey) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
function createBaseExpiryQueue() {
    return { id: "", value: [] };
}
exports.ExpiryQueue = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        for (const v of message.value) {
            writer.uint32(18).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExpiryQueue();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.value.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
            value: Array.isArray(object === null || object === void 0 ? void 0 : object.value)
                ? object.value.map((e) => String(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        if (message.value) {
            obj.value = message.value.map((e) => e);
        }
        else {
            obj.value = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseExpiryQueue();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : "";
        message.value = ((_b = object.value) === null || _b === void 0 ? void 0 : _b.map((e) => e)) || [];
        return message;
    },
};
function createBaseRecordsList() {
    return { value: [] };
}
exports.RecordsList = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        for (const v of message.value) {
            writer.uint32(10).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRecordsList();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.value.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            value: Array.isArray(object === null || object === void 0 ? void 0 : object.value)
                ? object.value.map((e) => String(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.value) {
            obj.value = message.value.map((e) => e);
        }
        else {
            obj.value = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseRecordsList();
        message.value = ((_a = object.value) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
function bytesFromBase64(b64) {
    if (globalThis.Buffer) {
        return Uint8Array.from(globalThis.Buffer.from(b64, "base64"));
    }
    else {
        const bin = globalThis.atob(b64);
        const arr = new Uint8Array(bin.length);
        for (let i = 0; i < bin.length; ++i) {
            arr[i] = bin.charCodeAt(i);
        }
        return arr;
    }
}
function base64FromBytes(arr) {
    if (globalThis.Buffer) {
        return globalThis.Buffer.from(arr).toString("base64");
    }
    else {
        const bin = [];
        arr.forEach((byte) => {
            bin.push(String.fromCharCode(byte));
        });
        return globalThis.btoa(bin.join(""));
    }
}
function toTimestamp(date) {
    const seconds = numberToLong(date.getTime() / 1000);
    const nanos = (date.getTime() % 1000) * 1000000;
    return { seconds, nanos };
}
function fromTimestamp(t) {
    let millis = t.seconds.toNumber() * 1000;
    millis += t.nanos / 1000000;
    return new Date(millis);
}
function fromJsonTimestamp(o) {
    if (o instanceof Date) {
        return o;
    }
    else if (typeof o === "string") {
        return new Date(o);
    }
    else {
        return fromTimestamp(timestamp_1.Timestamp.fromJSON(o));
    }
}
function numberToLong(number) {
    return long_1.default.fromNumber(number);
}
if (minimal_1.default.util.Long !== long_1.default) {
    minimal_1.default.util.Long = long_1.default;
    minimal_1.default.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
