import { Record, Params, Signature } from "./registry";
import Long from "long";
import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "cerc.registry.v1";
/** MsgSetRecord */
export interface MsgSetRecord {
    bondId: string;
    signer: string;
    payload?: Payload;
}
/** MsgSetRecordResponse */
export interface MsgSetRecordResponse {
    id: string;
}
/** Payload */
export interface Payload {
    record?: Record;
    signatures: Signature[];
}
/** MsgSetName */
export interface MsgSetName {
    lrn: string;
    cid: string;
    signer: string;
}
/** MsgSetNameResponse */
export interface MsgSetNameResponse {
}
/** MsgReserveAuthority */
export interface MsgReserveAuthority {
    name: string;
    signer: string;
    /** if creating a sub-authority. */
    owner: string;
}
/** MsgReserveAuthorityResponse */
export interface MsgReserveAuthorityResponse {
}
/** MsgSetAuthorityBond */
export interface MsgSetAuthorityBond {
    name: string;
    bondId: string;
    signer: string;
}
/** MsgSetAuthorityBondResponse */
export interface MsgSetAuthorityBondResponse {
}
/** MsgDeleteName */
export interface MsgDeleteName {
    lrn: string;
    signer: string;
}
/** MsgDeleteNameResponse */
export interface MsgDeleteNameResponse {
}
/** MsgRenewRecord */
export interface MsgRenewRecord {
    recordId: string;
    signer: string;
}
/** MsgRenewRecordResponse */
export interface MsgRenewRecordResponse {
}
/** MsgAssociateBond */
export interface MsgAssociateBond {
    recordId: string;
    bondId: string;
    signer: string;
}
/** MsgAssociateBondResponse */
export interface MsgAssociateBondResponse {
}
/** MsgDissociateBond */
export interface MsgDissociateBond {
    recordId: string;
    signer: string;
}
/** MsgDissociateBondResponse */
export interface MsgDissociateBondResponse {
}
/** MsgDissociateRecords */
export interface MsgDissociateRecords {
    bondId: string;
    signer: string;
}
/** MsgDissociateRecordsResponse */
export interface MsgDissociateRecordsResponse {
}
/** MsgReassociateRecords */
export interface MsgReassociateRecords {
    newBondId: string;
    oldBondId: string;
    signer: string;
}
/** MsgReassociateRecordsResponse */
export interface MsgReassociateRecordsResponse {
}
/** MsgUpdateParams is the Msg/UpdateParams request type. */
export interface MsgUpdateParams {
    /**
     * authority is the address that controls the module (defaults to x/gov unless
     * overwritten).
     */
    authority: string;
    /**
     * params defines the x/registry parameters to update.
     *
     * NOTE: All parameters must be supplied.
     */
    params?: Params;
}
/**
 * MsgUpdateParamsResponse defines the response structure for executing a
 * MsgUpdateParams message.
 */
export interface MsgUpdateParamsResponse {
}
export declare const MsgSetRecord: {
    encode(message: MsgSetRecord, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgSetRecord;
    fromJSON(object: any): MsgSetRecord;
    toJSON(message: MsgSetRecord): unknown;
    fromPartial<I extends {
        bondId?: string | undefined;
        signer?: string | undefined;
        payload?: {
            record?: {
                id?: string | undefined;
                bondId?: string | undefined;
                createTime?: string | undefined;
                expiryTime?: string | undefined;
                deleted?: boolean | undefined;
                owners?: string[] | undefined;
                attributes?: Uint8Array | undefined;
                names?: string[] | undefined;
                type?: string | undefined;
            } | undefined;
            signatures?: {
                sig?: string | undefined;
                pubKey?: string | undefined;
            }[] | undefined;
        } | undefined;
    } & {
        bondId?: string | undefined;
        signer?: string | undefined;
        payload?: ({
            record?: {
                id?: string | undefined;
                bondId?: string | undefined;
                createTime?: string | undefined;
                expiryTime?: string | undefined;
                deleted?: boolean | undefined;
                owners?: string[] | undefined;
                attributes?: Uint8Array | undefined;
                names?: string[] | undefined;
                type?: string | undefined;
            } | undefined;
            signatures?: {
                sig?: string | undefined;
                pubKey?: string | undefined;
            }[] | undefined;
        } & {
            record?: ({
                id?: string | undefined;
                bondId?: string | undefined;
                createTime?: string | undefined;
                expiryTime?: string | undefined;
                deleted?: boolean | undefined;
                owners?: string[] | undefined;
                attributes?: Uint8Array | undefined;
                names?: string[] | undefined;
                type?: string | undefined;
            } & {
                id?: string | undefined;
                bondId?: string | undefined;
                createTime?: string | undefined;
                expiryTime?: string | undefined;
                deleted?: boolean | undefined;
                owners?: (string[] & string[] & { [K in Exclude<keyof I["payload"]["record"]["owners"], keyof string[]>]: never; }) | undefined;
                attributes?: Uint8Array | undefined;
                names?: (string[] & string[] & { [K_1 in Exclude<keyof I["payload"]["record"]["names"], keyof string[]>]: never; }) | undefined;
                type?: string | undefined;
            } & { [K_2 in Exclude<keyof I["payload"]["record"], keyof Record>]: never; }) | undefined;
            signatures?: ({
                sig?: string | undefined;
                pubKey?: string | undefined;
            }[] & ({
                sig?: string | undefined;
                pubKey?: string | undefined;
            } & {
                sig?: string | undefined;
                pubKey?: string | undefined;
            } & { [K_3 in Exclude<keyof I["payload"]["signatures"][number], keyof Signature>]: never; })[] & { [K_4 in Exclude<keyof I["payload"]["signatures"], keyof {
                sig?: string | undefined;
                pubKey?: string | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_5 in Exclude<keyof I["payload"], keyof Payload>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, keyof MsgSetRecord>]: never; }>(object: I): MsgSetRecord;
};
export declare const MsgSetRecordResponse: {
    encode(message: MsgSetRecordResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgSetRecordResponse;
    fromJSON(object: any): MsgSetRecordResponse;
    toJSON(message: MsgSetRecordResponse): unknown;
    fromPartial<I extends {
        id?: string | undefined;
    } & {
        id?: string | undefined;
    } & { [K in Exclude<keyof I, "id">]: never; }>(object: I): MsgSetRecordResponse;
};
export declare const Payload: {
    encode(message: Payload, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): Payload;
    fromJSON(object: any): Payload;
    toJSON(message: Payload): unknown;
    fromPartial<I extends {
        record?: {
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        } | undefined;
        signatures?: {
            sig?: string | undefined;
            pubKey?: string | undefined;
        }[] | undefined;
    } & {
        record?: ({
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        } & {
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: (string[] & string[] & { [K in Exclude<keyof I["record"]["owners"], keyof string[]>]: never; }) | undefined;
            attributes?: Uint8Array | undefined;
            names?: (string[] & string[] & { [K_1 in Exclude<keyof I["record"]["names"], keyof string[]>]: never; }) | undefined;
            type?: string | undefined;
        } & { [K_2 in Exclude<keyof I["record"], keyof Record>]: never; }) | undefined;
        signatures?: ({
            sig?: string | undefined;
            pubKey?: string | undefined;
        }[] & ({
            sig?: string | undefined;
            pubKey?: string | undefined;
        } & {
            sig?: string | undefined;
            pubKey?: string | undefined;
        } & { [K_3 in Exclude<keyof I["signatures"][number], keyof Signature>]: never; })[] & { [K_4 in Exclude<keyof I["signatures"], keyof {
            sig?: string | undefined;
            pubKey?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_5 in Exclude<keyof I, keyof Payload>]: never; }>(object: I): Payload;
};
export declare const MsgSetName: {
    encode(message: MsgSetName, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgSetName;
    fromJSON(object: any): MsgSetName;
    toJSON(message: MsgSetName): unknown;
    fromPartial<I extends {
        lrn?: string | undefined;
        cid?: string | undefined;
        signer?: string | undefined;
    } & {
        lrn?: string | undefined;
        cid?: string | undefined;
        signer?: string | undefined;
    } & { [K in Exclude<keyof I, keyof MsgSetName>]: never; }>(object: I): MsgSetName;
};
export declare const MsgSetNameResponse: {
    encode(_: MsgSetNameResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgSetNameResponse;
    fromJSON(_: any): MsgSetNameResponse;
    toJSON(_: MsgSetNameResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgSetNameResponse;
};
export declare const MsgReserveAuthority: {
    encode(message: MsgReserveAuthority, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgReserveAuthority;
    fromJSON(object: any): MsgReserveAuthority;
    toJSON(message: MsgReserveAuthority): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        signer?: string | undefined;
        owner?: string | undefined;
    } & {
        name?: string | undefined;
        signer?: string | undefined;
        owner?: string | undefined;
    } & { [K in Exclude<keyof I, keyof MsgReserveAuthority>]: never; }>(object: I): MsgReserveAuthority;
};
export declare const MsgReserveAuthorityResponse: {
    encode(_: MsgReserveAuthorityResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgReserveAuthorityResponse;
    fromJSON(_: any): MsgReserveAuthorityResponse;
    toJSON(_: MsgReserveAuthorityResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgReserveAuthorityResponse;
};
export declare const MsgSetAuthorityBond: {
    encode(message: MsgSetAuthorityBond, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgSetAuthorityBond;
    fromJSON(object: any): MsgSetAuthorityBond;
    toJSON(message: MsgSetAuthorityBond): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        bondId?: string | undefined;
        signer?: string | undefined;
    } & {
        name?: string | undefined;
        bondId?: string | undefined;
        signer?: string | undefined;
    } & { [K in Exclude<keyof I, keyof MsgSetAuthorityBond>]: never; }>(object: I): MsgSetAuthorityBond;
};
export declare const MsgSetAuthorityBondResponse: {
    encode(_: MsgSetAuthorityBondResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgSetAuthorityBondResponse;
    fromJSON(_: any): MsgSetAuthorityBondResponse;
    toJSON(_: MsgSetAuthorityBondResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgSetAuthorityBondResponse;
};
export declare const MsgDeleteName: {
    encode(message: MsgDeleteName, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgDeleteName;
    fromJSON(object: any): MsgDeleteName;
    toJSON(message: MsgDeleteName): unknown;
    fromPartial<I extends {
        lrn?: string | undefined;
        signer?: string | undefined;
    } & {
        lrn?: string | undefined;
        signer?: string | undefined;
    } & { [K in Exclude<keyof I, keyof MsgDeleteName>]: never; }>(object: I): MsgDeleteName;
};
export declare const MsgDeleteNameResponse: {
    encode(_: MsgDeleteNameResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgDeleteNameResponse;
    fromJSON(_: any): MsgDeleteNameResponse;
    toJSON(_: MsgDeleteNameResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgDeleteNameResponse;
};
export declare const MsgRenewRecord: {
    encode(message: MsgRenewRecord, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgRenewRecord;
    fromJSON(object: any): MsgRenewRecord;
    toJSON(message: MsgRenewRecord): unknown;
    fromPartial<I extends {
        recordId?: string | undefined;
        signer?: string | undefined;
    } & {
        recordId?: string | undefined;
        signer?: string | undefined;
    } & { [K in Exclude<keyof I, keyof MsgRenewRecord>]: never; }>(object: I): MsgRenewRecord;
};
export declare const MsgRenewRecordResponse: {
    encode(_: MsgRenewRecordResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgRenewRecordResponse;
    fromJSON(_: any): MsgRenewRecordResponse;
    toJSON(_: MsgRenewRecordResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgRenewRecordResponse;
};
export declare const MsgAssociateBond: {
    encode(message: MsgAssociateBond, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgAssociateBond;
    fromJSON(object: any): MsgAssociateBond;
    toJSON(message: MsgAssociateBond): unknown;
    fromPartial<I extends {
        recordId?: string | undefined;
        bondId?: string | undefined;
        signer?: string | undefined;
    } & {
        recordId?: string | undefined;
        bondId?: string | undefined;
        signer?: string | undefined;
    } & { [K in Exclude<keyof I, keyof MsgAssociateBond>]: never; }>(object: I): MsgAssociateBond;
};
export declare const MsgAssociateBondResponse: {
    encode(_: MsgAssociateBondResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgAssociateBondResponse;
    fromJSON(_: any): MsgAssociateBondResponse;
    toJSON(_: MsgAssociateBondResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgAssociateBondResponse;
};
export declare const MsgDissociateBond: {
    encode(message: MsgDissociateBond, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgDissociateBond;
    fromJSON(object: any): MsgDissociateBond;
    toJSON(message: MsgDissociateBond): unknown;
    fromPartial<I extends {
        recordId?: string | undefined;
        signer?: string | undefined;
    } & {
        recordId?: string | undefined;
        signer?: string | undefined;
    } & { [K in Exclude<keyof I, keyof MsgDissociateBond>]: never; }>(object: I): MsgDissociateBond;
};
export declare const MsgDissociateBondResponse: {
    encode(_: MsgDissociateBondResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgDissociateBondResponse;
    fromJSON(_: any): MsgDissociateBondResponse;
    toJSON(_: MsgDissociateBondResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgDissociateBondResponse;
};
export declare const MsgDissociateRecords: {
    encode(message: MsgDissociateRecords, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgDissociateRecords;
    fromJSON(object: any): MsgDissociateRecords;
    toJSON(message: MsgDissociateRecords): unknown;
    fromPartial<I extends {
        bondId?: string | undefined;
        signer?: string | undefined;
    } & {
        bondId?: string | undefined;
        signer?: string | undefined;
    } & { [K in Exclude<keyof I, keyof MsgDissociateRecords>]: never; }>(object: I): MsgDissociateRecords;
};
export declare const MsgDissociateRecordsResponse: {
    encode(_: MsgDissociateRecordsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgDissociateRecordsResponse;
    fromJSON(_: any): MsgDissociateRecordsResponse;
    toJSON(_: MsgDissociateRecordsResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgDissociateRecordsResponse;
};
export declare const MsgReassociateRecords: {
    encode(message: MsgReassociateRecords, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgReassociateRecords;
    fromJSON(object: any): MsgReassociateRecords;
    toJSON(message: MsgReassociateRecords): unknown;
    fromPartial<I extends {
        newBondId?: string | undefined;
        oldBondId?: string | undefined;
        signer?: string | undefined;
    } & {
        newBondId?: string | undefined;
        oldBondId?: string | undefined;
        signer?: string | undefined;
    } & { [K in Exclude<keyof I, keyof MsgReassociateRecords>]: never; }>(object: I): MsgReassociateRecords;
};
export declare const MsgReassociateRecordsResponse: {
    encode(_: MsgReassociateRecordsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgReassociateRecordsResponse;
    fromJSON(_: any): MsgReassociateRecordsResponse;
    toJSON(_: MsgReassociateRecordsResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgReassociateRecordsResponse;
};
export declare const MsgUpdateParams: {
    encode(message: MsgUpdateParams, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgUpdateParams;
    fromJSON(object: any): MsgUpdateParams;
    toJSON(message: MsgUpdateParams): unknown;
    fromPartial<I extends {
        authority?: string | undefined;
        params?: {
            recordRent?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            recordRentDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityRent?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            authorityRentDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityGracePeriod?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityAuctionEnabled?: boolean | undefined;
            authorityAuctionCommitsDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityAuctionRevealsDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityAuctionCommitFee?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            authorityAuctionRevealFee?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            authorityAuctionMinimumBid?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
        } | undefined;
    } & {
        authority?: string | undefined;
        params?: ({
            recordRent?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            recordRentDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityRent?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            authorityRentDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityGracePeriod?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityAuctionEnabled?: boolean | undefined;
            authorityAuctionCommitsDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityAuctionRevealsDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityAuctionCommitFee?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            authorityAuctionRevealFee?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            authorityAuctionMinimumBid?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
        } & {
            recordRent?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K in Exclude<keyof I["params"]["recordRent"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
            recordRentDuration?: ({
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } & {
                seconds?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_1 in Exclude<keyof I["params"]["recordRentDuration"]["seconds"], keyof Long.Long>]: never; }) | undefined;
                nanos?: number | undefined;
            } & { [K_2 in Exclude<keyof I["params"]["recordRentDuration"], keyof import("../../../google/protobuf/duration").Duration>]: never; }) | undefined;
            authorityRent?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K_3 in Exclude<keyof I["params"]["authorityRent"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
            authorityRentDuration?: ({
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } & {
                seconds?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_4 in Exclude<keyof I["params"]["authorityRentDuration"]["seconds"], keyof Long.Long>]: never; }) | undefined;
                nanos?: number | undefined;
            } & { [K_5 in Exclude<keyof I["params"]["authorityRentDuration"], keyof import("../../../google/protobuf/duration").Duration>]: never; }) | undefined;
            authorityGracePeriod?: ({
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } & {
                seconds?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_6 in Exclude<keyof I["params"]["authorityGracePeriod"]["seconds"], keyof Long.Long>]: never; }) | undefined;
                nanos?: number | undefined;
            } & { [K_7 in Exclude<keyof I["params"]["authorityGracePeriod"], keyof import("../../../google/protobuf/duration").Duration>]: never; }) | undefined;
            authorityAuctionEnabled?: boolean | undefined;
            authorityAuctionCommitsDuration?: ({
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } & {
                seconds?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_8 in Exclude<keyof I["params"]["authorityAuctionCommitsDuration"]["seconds"], keyof Long.Long>]: never; }) | undefined;
                nanos?: number | undefined;
            } & { [K_9 in Exclude<keyof I["params"]["authorityAuctionCommitsDuration"], keyof import("../../../google/protobuf/duration").Duration>]: never; }) | undefined;
            authorityAuctionRevealsDuration?: ({
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } & {
                seconds?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_10 in Exclude<keyof I["params"]["authorityAuctionRevealsDuration"]["seconds"], keyof Long.Long>]: never; }) | undefined;
                nanos?: number | undefined;
            } & { [K_11 in Exclude<keyof I["params"]["authorityAuctionRevealsDuration"], keyof import("../../../google/protobuf/duration").Duration>]: never; }) | undefined;
            authorityAuctionCommitFee?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K_12 in Exclude<keyof I["params"]["authorityAuctionCommitFee"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
            authorityAuctionRevealFee?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K_13 in Exclude<keyof I["params"]["authorityAuctionRevealFee"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
            authorityAuctionMinimumBid?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K_14 in Exclude<keyof I["params"]["authorityAuctionMinimumBid"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
        } & { [K_15 in Exclude<keyof I["params"], keyof Params>]: never; }) | undefined;
    } & { [K_16 in Exclude<keyof I, keyof MsgUpdateParams>]: never; }>(object: I): MsgUpdateParams;
};
export declare const MsgUpdateParamsResponse: {
    encode(_: MsgUpdateParamsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgUpdateParamsResponse;
    fromJSON(_: any): MsgUpdateParamsResponse;
    toJSON(_: MsgUpdateParamsResponse): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): MsgUpdateParamsResponse;
};
/** Msg is a service which exposes the registry functionality */
export interface Msg {
    /** SetRecord records a new record with given payload and bond id */
    SetRecord(request: MsgSetRecord): Promise<MsgSetRecordResponse>;
    /** Renew Record renews an expired record */
    RenewRecord(request: MsgRenewRecord): Promise<MsgRenewRecordResponse>;
    /** AssociateBond */
    AssociateBond(request: MsgAssociateBond): Promise<MsgAssociateBondResponse>;
    /** DissociateBond */
    DissociateBond(request: MsgDissociateBond): Promise<MsgDissociateBondResponse>;
    /** DissociateRecords */
    DissociateRecords(request: MsgDissociateRecords): Promise<MsgDissociateRecordsResponse>;
    /** ReassociateRecords */
    ReassociateRecords(request: MsgReassociateRecords): Promise<MsgReassociateRecordsResponse>;
    /** SetName will store the name with given lrn and name */
    SetName(request: MsgSetName): Promise<MsgSetNameResponse>;
    /** Delete Name method will remove authority name */
    DeleteName(request: MsgDeleteName): Promise<MsgDeleteNameResponse>;
    /** Reserve authority name */
    ReserveAuthority(request: MsgReserveAuthority): Promise<MsgReserveAuthorityResponse>;
    /** SetAuthorityBond */
    SetAuthorityBond(request: MsgSetAuthorityBond): Promise<MsgSetAuthorityBondResponse>;
    /**
     * UpdateParams defines an operation for updating the x/staking module
     * parameters.
     */
    UpdateParams(request: MsgUpdateParams): Promise<MsgUpdateParamsResponse>;
}
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    constructor(rpc: Rpc);
    SetRecord(request: MsgSetRecord): Promise<MsgSetRecordResponse>;
    RenewRecord(request: MsgRenewRecord): Promise<MsgRenewRecordResponse>;
    AssociateBond(request: MsgAssociateBond): Promise<MsgAssociateBondResponse>;
    DissociateBond(request: MsgDissociateBond): Promise<MsgDissociateBondResponse>;
    DissociateRecords(request: MsgDissociateRecords): Promise<MsgDissociateRecordsResponse>;
    ReassociateRecords(request: MsgReassociateRecords): Promise<MsgReassociateRecordsResponse>;
    SetName(request: MsgSetName): Promise<MsgSetNameResponse>;
    DeleteName(request: MsgDeleteName): Promise<MsgDeleteNameResponse>;
    ReserveAuthority(request: MsgReserveAuthority): Promise<MsgReserveAuthorityResponse>;
    SetAuthorityBond(request: MsgSetAuthorityBond): Promise<MsgSetAuthorityBondResponse>;
    UpdateParams(request: MsgUpdateParams): Promise<MsgUpdateParamsResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export {};
