"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MsgClientImpl = exports.MsgUpdateParamsResponse = exports.MsgUpdateParams = exports.MsgReassociateRecordsResponse = exports.MsgReassociateRecords = exports.MsgDissociateRecordsResponse = exports.MsgDissociateRecords = exports.MsgDissociateBondResponse = exports.MsgDissociateBond = exports.MsgAssociateBondResponse = exports.MsgAssociateBond = exports.MsgRenewRecordResponse = exports.MsgRenewRecord = exports.MsgDeleteNameResponse = exports.MsgDeleteName = exports.MsgSetAuthorityBondResponse = exports.MsgSetAuthorityBond = exports.MsgReserveAuthorityResponse = exports.MsgReserveAuthority = exports.MsgSetNameResponse = exports.MsgSetName = exports.Payload = exports.MsgSetRecordResponse = exports.MsgSetRecord = exports.protobufPackage = void 0;
/* eslint-disable */
const registry_1 = require("./registry");
const long_1 = __importDefault(require("long"));
const minimal_1 = __importDefault(require("protobufjs/minimal"));
exports.protobufPackage = "cerc.registry.v1";
function createBaseMsgSetRecord() {
    return { bondId: "", signer: "", payload: undefined };
}
exports.MsgSetRecord = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.bondId !== "") {
            writer.uint32(10).string(message.bondId);
        }
        if (message.signer !== "") {
            writer.uint32(18).string(message.signer);
        }
        if (message.payload !== undefined) {
            exports.Payload.encode(message.payload, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgSetRecord();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.bondId = reader.string();
                    break;
                case 2:
                    message.signer = reader.string();
                    break;
                case 3:
                    message.payload = exports.Payload.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            bondId: isSet(object.bondId) ? String(object.bondId) : "",
            signer: isSet(object.signer) ? String(object.signer) : "",
            payload: isSet(object.payload)
                ? exports.Payload.fromJSON(object.payload)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.bondId !== undefined && (obj.bondId = message.bondId);
        message.signer !== undefined && (obj.signer = message.signer);
        message.payload !== undefined &&
            (obj.payload = message.payload
                ? exports.Payload.toJSON(message.payload)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseMsgSetRecord();
        message.bondId = (_a = object.bondId) !== null && _a !== void 0 ? _a : "";
        message.signer = (_b = object.signer) !== null && _b !== void 0 ? _b : "";
        message.payload =
            object.payload !== undefined && object.payload !== null
                ? exports.Payload.fromPartial(object.payload)
                : undefined;
        return message;
    },
};
function createBaseMsgSetRecordResponse() {
    return { id: "" };
}
exports.MsgSetRecordResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgSetRecordResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseMsgSetRecordResponse();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBasePayload() {
    return { record: undefined, signatures: [] };
}
exports.Payload = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.record !== undefined) {
            registry_1.Record.encode(message.record, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.signatures) {
            registry_1.Signature.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePayload();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.record = registry_1.Record.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.signatures.push(registry_1.Signature.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            record: isSet(object.record) ? registry_1.Record.fromJSON(object.record) : undefined,
            signatures: Array.isArray(object === null || object === void 0 ? void 0 : object.signatures)
                ? object.signatures.map((e) => registry_1.Signature.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.record !== undefined &&
            (obj.record = message.record ? registry_1.Record.toJSON(message.record) : undefined);
        if (message.signatures) {
            obj.signatures = message.signatures.map((e) => e ? registry_1.Signature.toJSON(e) : undefined);
        }
        else {
            obj.signatures = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePayload();
        message.record =
            object.record !== undefined && object.record !== null
                ? registry_1.Record.fromPartial(object.record)
                : undefined;
        message.signatures =
            ((_a = object.signatures) === null || _a === void 0 ? void 0 : _a.map((e) => registry_1.Signature.fromPartial(e))) || [];
        return message;
    },
};
function createBaseMsgSetName() {
    return { lrn: "", cid: "", signer: "" };
}
exports.MsgSetName = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.lrn !== "") {
            writer.uint32(10).string(message.lrn);
        }
        if (message.cid !== "") {
            writer.uint32(18).string(message.cid);
        }
        if (message.signer !== "") {
            writer.uint32(26).string(message.signer);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgSetName();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.lrn = reader.string();
                    break;
                case 2:
                    message.cid = reader.string();
                    break;
                case 3:
                    message.signer = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            lrn: isSet(object.lrn) ? String(object.lrn) : "",
            cid: isSet(object.cid) ? String(object.cid) : "",
            signer: isSet(object.signer) ? String(object.signer) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.lrn !== undefined && (obj.lrn = message.lrn);
        message.cid !== undefined && (obj.cid = message.cid);
        message.signer !== undefined && (obj.signer = message.signer);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseMsgSetName();
        message.lrn = (_a = object.lrn) !== null && _a !== void 0 ? _a : "";
        message.cid = (_b = object.cid) !== null && _b !== void 0 ? _b : "";
        message.signer = (_c = object.signer) !== null && _c !== void 0 ? _c : "";
        return message;
    },
};
function createBaseMsgSetNameResponse() {
    return {};
}
exports.MsgSetNameResponse = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgSetNameResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgSetNameResponse();
        return message;
    },
};
function createBaseMsgReserveAuthority() {
    return { name: "", signer: "", owner: "" };
}
exports.MsgReserveAuthority = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.name !== "") {
            writer.uint32(10).string(message.name);
        }
        if (message.signer !== "") {
            writer.uint32(18).string(message.signer);
        }
        if (message.owner !== "") {
            writer.uint32(26).string(message.owner);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgReserveAuthority();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.signer = reader.string();
                    break;
                case 3:
                    message.owner = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            signer: isSet(object.signer) ? String(object.signer) : "",
            owner: isSet(object.owner) ? String(object.owner) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.signer !== undefined && (obj.signer = message.signer);
        message.owner !== undefined && (obj.owner = message.owner);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseMsgReserveAuthority();
        message.name = (_a = object.name) !== null && _a !== void 0 ? _a : "";
        message.signer = (_b = object.signer) !== null && _b !== void 0 ? _b : "";
        message.owner = (_c = object.owner) !== null && _c !== void 0 ? _c : "";
        return message;
    },
};
function createBaseMsgReserveAuthorityResponse() {
    return {};
}
exports.MsgReserveAuthorityResponse = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgReserveAuthorityResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgReserveAuthorityResponse();
        return message;
    },
};
function createBaseMsgSetAuthorityBond() {
    return { name: "", bondId: "", signer: "" };
}
exports.MsgSetAuthorityBond = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.name !== "") {
            writer.uint32(10).string(message.name);
        }
        if (message.bondId !== "") {
            writer.uint32(18).string(message.bondId);
        }
        if (message.signer !== "") {
            writer.uint32(26).string(message.signer);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgSetAuthorityBond();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.bondId = reader.string();
                    break;
                case 3:
                    message.signer = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            bondId: isSet(object.bondId) ? String(object.bondId) : "",
            signer: isSet(object.signer) ? String(object.signer) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.bondId !== undefined && (obj.bondId = message.bondId);
        message.signer !== undefined && (obj.signer = message.signer);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseMsgSetAuthorityBond();
        message.name = (_a = object.name) !== null && _a !== void 0 ? _a : "";
        message.bondId = (_b = object.bondId) !== null && _b !== void 0 ? _b : "";
        message.signer = (_c = object.signer) !== null && _c !== void 0 ? _c : "";
        return message;
    },
};
function createBaseMsgSetAuthorityBondResponse() {
    return {};
}
exports.MsgSetAuthorityBondResponse = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgSetAuthorityBondResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgSetAuthorityBondResponse();
        return message;
    },
};
function createBaseMsgDeleteName() {
    return { lrn: "", signer: "" };
}
exports.MsgDeleteName = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.lrn !== "") {
            writer.uint32(10).string(message.lrn);
        }
        if (message.signer !== "") {
            writer.uint32(18).string(message.signer);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgDeleteName();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.lrn = reader.string();
                    break;
                case 2:
                    message.signer = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            lrn: isSet(object.lrn) ? String(object.lrn) : "",
            signer: isSet(object.signer) ? String(object.signer) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.lrn !== undefined && (obj.lrn = message.lrn);
        message.signer !== undefined && (obj.signer = message.signer);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseMsgDeleteName();
        message.lrn = (_a = object.lrn) !== null && _a !== void 0 ? _a : "";
        message.signer = (_b = object.signer) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
function createBaseMsgDeleteNameResponse() {
    return {};
}
exports.MsgDeleteNameResponse = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgDeleteNameResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgDeleteNameResponse();
        return message;
    },
};
function createBaseMsgRenewRecord() {
    return { recordId: "", signer: "" };
}
exports.MsgRenewRecord = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.recordId !== "") {
            writer.uint32(10).string(message.recordId);
        }
        if (message.signer !== "") {
            writer.uint32(18).string(message.signer);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgRenewRecord();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.recordId = reader.string();
                    break;
                case 2:
                    message.signer = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            recordId: isSet(object.recordId) ? String(object.recordId) : "",
            signer: isSet(object.signer) ? String(object.signer) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.recordId !== undefined && (obj.recordId = message.recordId);
        message.signer !== undefined && (obj.signer = message.signer);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseMsgRenewRecord();
        message.recordId = (_a = object.recordId) !== null && _a !== void 0 ? _a : "";
        message.signer = (_b = object.signer) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
function createBaseMsgRenewRecordResponse() {
    return {};
}
exports.MsgRenewRecordResponse = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgRenewRecordResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgRenewRecordResponse();
        return message;
    },
};
function createBaseMsgAssociateBond() {
    return { recordId: "", bondId: "", signer: "" };
}
exports.MsgAssociateBond = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.recordId !== "") {
            writer.uint32(10).string(message.recordId);
        }
        if (message.bondId !== "") {
            writer.uint32(18).string(message.bondId);
        }
        if (message.signer !== "") {
            writer.uint32(26).string(message.signer);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgAssociateBond();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.recordId = reader.string();
                    break;
                case 2:
                    message.bondId = reader.string();
                    break;
                case 3:
                    message.signer = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            recordId: isSet(object.recordId) ? String(object.recordId) : "",
            bondId: isSet(object.bondId) ? String(object.bondId) : "",
            signer: isSet(object.signer) ? String(object.signer) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.recordId !== undefined && (obj.recordId = message.recordId);
        message.bondId !== undefined && (obj.bondId = message.bondId);
        message.signer !== undefined && (obj.signer = message.signer);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseMsgAssociateBond();
        message.recordId = (_a = object.recordId) !== null && _a !== void 0 ? _a : "";
        message.bondId = (_b = object.bondId) !== null && _b !== void 0 ? _b : "";
        message.signer = (_c = object.signer) !== null && _c !== void 0 ? _c : "";
        return message;
    },
};
function createBaseMsgAssociateBondResponse() {
    return {};
}
exports.MsgAssociateBondResponse = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgAssociateBondResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgAssociateBondResponse();
        return message;
    },
};
function createBaseMsgDissociateBond() {
    return { recordId: "", signer: "" };
}
exports.MsgDissociateBond = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.recordId !== "") {
            writer.uint32(10).string(message.recordId);
        }
        if (message.signer !== "") {
            writer.uint32(18).string(message.signer);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgDissociateBond();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.recordId = reader.string();
                    break;
                case 2:
                    message.signer = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            recordId: isSet(object.recordId) ? String(object.recordId) : "",
            signer: isSet(object.signer) ? String(object.signer) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.recordId !== undefined && (obj.recordId = message.recordId);
        message.signer !== undefined && (obj.signer = message.signer);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseMsgDissociateBond();
        message.recordId = (_a = object.recordId) !== null && _a !== void 0 ? _a : "";
        message.signer = (_b = object.signer) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
function createBaseMsgDissociateBondResponse() {
    return {};
}
exports.MsgDissociateBondResponse = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgDissociateBondResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgDissociateBondResponse();
        return message;
    },
};
function createBaseMsgDissociateRecords() {
    return { bondId: "", signer: "" };
}
exports.MsgDissociateRecords = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.bondId !== "") {
            writer.uint32(10).string(message.bondId);
        }
        if (message.signer !== "") {
            writer.uint32(18).string(message.signer);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgDissociateRecords();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.bondId = reader.string();
                    break;
                case 2:
                    message.signer = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            bondId: isSet(object.bondId) ? String(object.bondId) : "",
            signer: isSet(object.signer) ? String(object.signer) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.bondId !== undefined && (obj.bondId = message.bondId);
        message.signer !== undefined && (obj.signer = message.signer);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseMsgDissociateRecords();
        message.bondId = (_a = object.bondId) !== null && _a !== void 0 ? _a : "";
        message.signer = (_b = object.signer) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
function createBaseMsgDissociateRecordsResponse() {
    return {};
}
exports.MsgDissociateRecordsResponse = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgDissociateRecordsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgDissociateRecordsResponse();
        return message;
    },
};
function createBaseMsgReassociateRecords() {
    return { newBondId: "", oldBondId: "", signer: "" };
}
exports.MsgReassociateRecords = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.newBondId !== "") {
            writer.uint32(10).string(message.newBondId);
        }
        if (message.oldBondId !== "") {
            writer.uint32(18).string(message.oldBondId);
        }
        if (message.signer !== "") {
            writer.uint32(26).string(message.signer);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgReassociateRecords();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.newBondId = reader.string();
                    break;
                case 2:
                    message.oldBondId = reader.string();
                    break;
                case 3:
                    message.signer = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            newBondId: isSet(object.newBondId) ? String(object.newBondId) : "",
            oldBondId: isSet(object.oldBondId) ? String(object.oldBondId) : "",
            signer: isSet(object.signer) ? String(object.signer) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.newBondId !== undefined && (obj.newBondId = message.newBondId);
        message.oldBondId !== undefined && (obj.oldBondId = message.oldBondId);
        message.signer !== undefined && (obj.signer = message.signer);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseMsgReassociateRecords();
        message.newBondId = (_a = object.newBondId) !== null && _a !== void 0 ? _a : "";
        message.oldBondId = (_b = object.oldBondId) !== null && _b !== void 0 ? _b : "";
        message.signer = (_c = object.signer) !== null && _c !== void 0 ? _c : "";
        return message;
    },
};
function createBaseMsgReassociateRecordsResponse() {
    return {};
}
exports.MsgReassociateRecordsResponse = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgReassociateRecordsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgReassociateRecordsResponse();
        return message;
    },
};
function createBaseMsgUpdateParams() {
    return { authority: "", params: undefined };
}
exports.MsgUpdateParams = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.authority !== "") {
            writer.uint32(10).string(message.authority);
        }
        if (message.params !== undefined) {
            registry_1.Params.encode(message.params, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgUpdateParams();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.authority = reader.string();
                    break;
                case 2:
                    message.params = registry_1.Params.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            authority: isSet(object.authority) ? String(object.authority) : "",
            params: isSet(object.params) ? registry_1.Params.fromJSON(object.params) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.authority !== undefined && (obj.authority = message.authority);
        message.params !== undefined &&
            (obj.params = message.params ? registry_1.Params.toJSON(message.params) : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseMsgUpdateParams();
        message.authority = (_a = object.authority) !== null && _a !== void 0 ? _a : "";
        message.params =
            object.params !== undefined && object.params !== null
                ? registry_1.Params.fromPartial(object.params)
                : undefined;
        return message;
    },
};
function createBaseMsgUpdateParamsResponse() {
    return {};
}
exports.MsgUpdateParamsResponse = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgUpdateParamsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgUpdateParamsResponse();
        return message;
    },
};
class MsgClientImpl {
    constructor(rpc) {
        this.rpc = rpc;
        this.SetRecord = this.SetRecord.bind(this);
        this.RenewRecord = this.RenewRecord.bind(this);
        this.AssociateBond = this.AssociateBond.bind(this);
        this.DissociateBond = this.DissociateBond.bind(this);
        this.DissociateRecords = this.DissociateRecords.bind(this);
        this.ReassociateRecords = this.ReassociateRecords.bind(this);
        this.SetName = this.SetName.bind(this);
        this.DeleteName = this.DeleteName.bind(this);
        this.ReserveAuthority = this.ReserveAuthority.bind(this);
        this.SetAuthorityBond = this.SetAuthorityBond.bind(this);
        this.UpdateParams = this.UpdateParams.bind(this);
    }
    SetRecord(request) {
        const data = exports.MsgSetRecord.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Msg", "SetRecord", data);
        return promise.then((data) => exports.MsgSetRecordResponse.decode(new minimal_1.default.Reader(data)));
    }
    RenewRecord(request) {
        const data = exports.MsgRenewRecord.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Msg", "RenewRecord", data);
        return promise.then((data) => exports.MsgRenewRecordResponse.decode(new minimal_1.default.Reader(data)));
    }
    AssociateBond(request) {
        const data = exports.MsgAssociateBond.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Msg", "AssociateBond", data);
        return promise.then((data) => exports.MsgAssociateBondResponse.decode(new minimal_1.default.Reader(data)));
    }
    DissociateBond(request) {
        const data = exports.MsgDissociateBond.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Msg", "DissociateBond", data);
        return promise.then((data) => exports.MsgDissociateBondResponse.decode(new minimal_1.default.Reader(data)));
    }
    DissociateRecords(request) {
        const data = exports.MsgDissociateRecords.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Msg", "DissociateRecords", data);
        return promise.then((data) => exports.MsgDissociateRecordsResponse.decode(new minimal_1.default.Reader(data)));
    }
    ReassociateRecords(request) {
        const data = exports.MsgReassociateRecords.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Msg", "ReassociateRecords", data);
        return promise.then((data) => exports.MsgReassociateRecordsResponse.decode(new minimal_1.default.Reader(data)));
    }
    SetName(request) {
        const data = exports.MsgSetName.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Msg", "SetName", data);
        return promise.then((data) => exports.MsgSetNameResponse.decode(new minimal_1.default.Reader(data)));
    }
    DeleteName(request) {
        const data = exports.MsgDeleteName.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Msg", "DeleteName", data);
        return promise.then((data) => exports.MsgDeleteNameResponse.decode(new minimal_1.default.Reader(data)));
    }
    ReserveAuthority(request) {
        const data = exports.MsgReserveAuthority.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Msg", "ReserveAuthority", data);
        return promise.then((data) => exports.MsgReserveAuthorityResponse.decode(new minimal_1.default.Reader(data)));
    }
    SetAuthorityBond(request) {
        const data = exports.MsgSetAuthorityBond.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Msg", "SetAuthorityBond", data);
        return promise.then((data) => exports.MsgSetAuthorityBondResponse.decode(new minimal_1.default.Reader(data)));
    }
    UpdateParams(request) {
        const data = exports.MsgUpdateParams.encode(request).finish();
        const promise = this.rpc.request("cerc.registry.v1.Msg", "UpdateParams", data);
        return promise.then((data) => exports.MsgUpdateParamsResponse.decode(new minimal_1.default.Reader(data)));
    }
}
exports.MsgClientImpl = MsgClientImpl;
if (minimal_1.default.util.Long !== long_1.default) {
    minimal_1.default.util.Long = long_1.default;
    minimal_1.default.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
