import { EncodeObject, GeneratedType } from '@cosmjs/proto-signing';
import { MsgCommitBid, MsgRevealBid, MsgCreateAuction, MsgReleaseFunds } from '../../../proto/cerc/auction/v1/tx';
export declare const typeUrlMsgCreateAuction = "/cerc.auction.v1.MsgCreateAuction";
export declare const typeUrlMsgCommitBid = "/cerc.auction.v1.MsgCommitBid";
export declare const typeUrlMsgCommitBidResponse = "/cerc.auction.v1.MsgCommitBidResponse";
export declare const typeUrlMsgRevealBid = "/cerc.auction.v1.MsgRevealBid";
export declare const typeUrlMsgRevealBidResponse = "/cerc.auction.v1.MsgRevealBidResponse";
export declare const typeUrlMsgCreateAuctionResponse = "/cerc.auction.v1.MsgCreateAuctionResponse";
export declare const typeUrlMsgReleaseFunds = "/cerc.auction.v1.MsgReleaseFunds";
export declare const typeUrlMsgReleaseFundsResponse = "/cerc.auction.v1.MsgReleaseFundsResponse";
export declare const auctionTypes: ReadonlyArray<[string, GeneratedType]>;
export interface MsgCreateAuctionEncodeObject extends EncodeObject {
    readonly typeUrl: '/cerc.auction.v1.MsgCreateAuction';
    readonly value: Partial<MsgCreateAuction>;
}
export interface MsgCommitBidEncodeObject extends EncodeObject {
    readonly typeUrl: '/cerc.auction.v1.MsgCommitBid';
    readonly value: Partial<MsgCommitBid>;
}
export interface MsgRevealBidEncodeObject extends EncodeObject {
    readonly typeUrl: '/cerc.auction.v1.MsgRevealBid';
    readonly value: Partial<MsgRevealBid>;
}
export interface MsgReleaseFundsEncodeObject extends EncodeObject {
    readonly typeUrl: '/cerc.auction.v1.MsgReleaseFunds';
    readonly value: Partial<MsgReleaseFunds>;
}
export declare const INVALID_BID_ERROR = "Bid is higher than max price";
export declare const RELEASE_FUNDS_ERROR = "Auction funds already released";
export declare const OWNER_MISMATCH_ERROR = "Only auction owner can release funds";
export declare const AUCTION_ERRORS: string[];
export interface MessageMsgCommitBid {
    auctionId: string;
    commitHash: string;
}
export interface MessageMsgRevealBid {
    auctionId: string;
    reveal: string;
}
export interface MessageCreateVickreyAuction {
    commitsDuration: string;
    revealsDuration: string;
    denom: string;
    commitFee: string;
    revealFee: string;
    minimumBid: string;
}
export interface MessageCreateProviderAuction {
    commitsDuration: string;
    revealsDuration: string;
    denom: string;
    commitFee: string;
    revealFee: string;
    maxPrice: string;
    numProviders: number;
}
export interface MessageMsgReleaseFunds {
    auctionId: string;
}
