import { EncodeObject, GeneratedType } from '@cosmjs/proto-signing';
import { MsgReserveAuthority, MsgSetAuthorityBond, MsgSetRecord, MsgSetName, MsgDeleteName, MsgAssociateBond, MsgDissociateBond, MsgDissociateRecords, MsgReassociateRecords } from '../../../proto/cerc/registry/v1/tx';
export declare const typeUrlMsgReserveAuthority = "/cerc.registry.v1.MsgReserveAuthority";
export declare const typeUrlMsgSetRecord = "/cerc.registry.v1.MsgSetRecord";
export declare const typeUrlMsgSetAuthorityBond = "/cerc.registry.v1.MsgSetAuthorityBond";
export declare const typeUrlMsgReserveAuthorityResponse = "/cerc.registry.v1.MsgReserveAuthorityResponse";
export declare const typeUrlMsgSetRecordResponse = "/cerc.registry.v1.MsgSetRecordResponse";
export declare const typeUrlMsgSetAuthorityBondResponse = "/cerc.registry.v1.MsgSetAuthorityBondResponse";
export declare const typeUrlMsgSetName = "/cerc.registry.v1.MsgSetName";
export declare const typeUrlMsgSetNameResponse = "/cerc.registry.v1.MsgSetNameResponse";
export declare const typeUrlMsgDeleteName = "/cerc.registry.v1.MsgDeleteName";
export declare const typeUrlMsgDeleteNameResponse = "/cerc.registry.v1.MsgDeleteNameResponse";
export declare const typeUrlMsgAssociateBond = "/cerc.registry.v1.MsgAssociateBond";
export declare const typeUrlMsgDissociateBond = "/cerc.registry.v1.MsgDissociateBond";
export declare const typeUrlMsgAssociateBondResponse = "/cerc.registry.v1.MsgAssociateBondResponse";
export declare const typeUrlMsgDissociateBondResponse = "/cerc.registry.v1.MsgDissociateBondResponse";
export declare const typeUrlMsgDissociateRecords = "/cerc.registry.v1.MsgDissociateRecords";
export declare const typeUrlMsgReassociateRecords = "/cerc.registry.v1.MsgReassociateRecords";
export declare const typeUrlMsgDissociateRecordsResponse = "/cerc.registry.v1.MsgDissociateRecordsResponse";
export declare const typeUrlMsgReassociateRecordsResponse = "/cerc.registry.v1.MsgReassociateRecordsResponse";
export declare const registryTypes: ReadonlyArray<[string, GeneratedType]>;
export interface MsgReserveAuthorityEncodeObject extends EncodeObject {
    readonly typeUrl: '/cerc.registry.v1.MsgReserveAuthority';
    readonly value: Partial<MsgReserveAuthority>;
}
export interface MsgSetRecordEncodeObject extends EncodeObject {
    readonly typeUrl: '/cerc.registry.v1.MsgSetRecord';
    readonly value: Partial<MsgSetRecord>;
}
export interface MsgSetAuthorityBondEncodeObject extends EncodeObject {
    readonly typeUrl: '/cerc.registry.v1.MsgSetAuthorityBond';
    readonly value: Partial<MsgSetAuthorityBond>;
}
export interface MsgSetNameEncodeObject extends EncodeObject {
    readonly typeUrl: '/cerc.registry.v1.MsgSetName';
    readonly value: Partial<MsgSetName>;
}
export interface MsgDeleteNameEncodeObject extends EncodeObject {
    readonly typeUrl: '/cerc.registry.v1.MsgDeleteName';
    readonly value: Partial<MsgDeleteName>;
}
export interface MsgAssociateBondEncodeObject extends EncodeObject {
    readonly typeUrl: '/cerc.registry.v1.MsgAssociateBond';
    readonly value: Partial<MsgAssociateBond>;
}
export interface MsgDissociateBondEncodeObject extends EncodeObject {
    readonly typeUrl: '/cerc.registry.v1.MsgDissociateBond';
    readonly value: Partial<MsgDissociateBond>;
}
export interface MsgDissociateRecordsEncodeObject extends EncodeObject {
    readonly typeUrl: '/cerc.registry.v1.MsgDissociateRecords';
    readonly value: Partial<MsgDissociateRecords>;
}
export interface MsgReassociateRecordsEncodeObject extends EncodeObject {
    readonly typeUrl: '/cerc.registry.v1.MsgReassociateRecords';
    readonly value: Partial<MsgReassociateRecords>;
}
export declare const NAMESERVICE_ERRORS: string[];
export interface MessageMsgReserveAuthority {
    name: string;
    owner: string;
}
export interface MessageMsgSetName {
    lrn: string;
    cid: string;
}
export interface MessageMsgSetAuthorityBond {
    name: string;
    bondId: string;
}
export interface MessageMsgDeleteName {
    lrn: string;
}
